#!perl -w

# WEBSITE BENCHMARK EMULATION PROGRAM !

$SITE = 'http://localhost/test.fcgi';

# set between 1 to 5 (if you have more RAM you should increase this value)
# if too high, the program will terminated (this is the limit of your webserver can handle)
$BENCHMARK_LEVEL = 5;		# DEFAULT VALUE: 3

# set $TIMEOUT around 10 to 180  (default: 120)
# if you set this value too low, you will get FAILED msg (request failed)
$TIMEOUT = 30;		# number of seconds to wait response



# $BENCHMARK_LEVEL WARNING !!
# Calculations:
# 2 ** $BENCHMARK_LEVEL = total child process

# BENCHMARK_LEVEL => total maximum request generated / second (approx. per 1-2 second)
# 1 => 2 request/s
# 2 => 4 request/s
# 3 => 8 request/s
# 4 => 16 request/s
# 5 => 32 request/s
# 6 => 64 request/s
# 7 => 128 request/s


# TESTED UNDER:
# Processor: Intel(R) Celeron(R) CPU 1.70GHz
# Memory: 224MB RAM
# Operating System: Linux SUSE 10
# Operating System: Windows XP Professional (5.1, Build 2600) Service Pack 2 (2600.xpsp_sp2_rtm.040803-2158)
# Apache/2.0.58 (Win32) mod_perl/2.0.2 Perl/v5.8.8


for ($i= 0; $i < $BENCHMARK_LEVEL; $i++ ) {
	my $child_pid = fork;
	#waitpid($child_pid, 0);		# disable waitpid to get a real benchmarking program (slowing down)
}


use LWP::UserAgent;
 
my $ua = LWP::UserAgent->new;
$ua->timeout($TIMEOUT);		# wait for 2 minutes
$ua->env_proxy;
 
my $response = $ua->get($SITE);

if ($response->is_success) {
	#print $response->content;  # or whatever
	print "ok\n";;
} else {
	#die $response->status_line;
	print "FAILED !!!!!!!\n";
}



