
CREATE TABLE `banner` (
client		varchar(16) default null,		-- google, adbrite, text-ad-links
advert_code	varchar(2048) default null,
primary key (client)
);

CREATE TABLE `statistic` (
total_author			bigint unsigned not null,
total_topic			bigint unsigned not null,
total_comment		bigint unsigned not null,
total_band			bigint unsigned not null
);

CREATE TABLE `temp_topic` (
title			varchar(128) not null,
description	text default null,
imageurl		varchar(750) default null,			-- no html filter, just quotemeta(), content can be flash or jpeg/gif
nid			bigint unsigned not null,			-- 0 is Guest
aid			bigint unsigned not null,			-- 0 is Guest
tdate		varchar(10) not null,
ip_address	varchar(15) default null,
index (nid, aid)
);

CREATE TABLE `temp_page` (
krack_id		varchar(32) default null,
title			varchar(128) not null,
description	text default null,
aid			bigint unsigned not null,			-- 0 is Guest
pdate		varchar(10) not null,
ip_address	varchar(15) default null,
index (aid)
);

CREATE TABLE `temp_author` (
email			varchar(64) not null,
name			varchar(16) not null,
password		varchar(16) not null,		-- encrypted !  using Digest::MD5 -> NEED MORE SPACES varchar(40)
www			varchar(32) not null,
country			varchar(32) not null,
confirm_code	varchar(40) not null,
primary key (email)
);

CREATE TABLE `page` (
pid			bigint unsigned auto_increment not null,
krack_id		varchar(32) default null,
aid			bigint unsigned default 0,			-- (aid = 0 or NULL) is GUEST
title			varchar(128) not null,
description	text default null,
pdate		varchar(10) not null,
is_locked	int not null,
total_comment	int default 0,
ip_address	varchar(15) default null,
primary key (pid),
index (aid)
);

CREATE TABLE `author` (
aid			bigint unsigned auto_increment not null,		-- 0: guest. 0 is  not exist anyway :-)
name		varchar(16) not null,			-- if `aid` eq 1 THEN name eq 'guest'
email		varchar(64) default null,
rank		int not null,						-- 0: guest, 1: user, 2: editor, 3: admin
editor_node	varchar(32) default null,		-- 1;3;6;8; (SEPARATED BY SEMICOLON)	-- ADMIN automatically control all `nid`
password	varchar(40) default null,
www		varchar(32) default null,
date_joined	varchar(10) default null,
birth_date	varchar(10) default null,
location		varchar(32) default null,
country		varchar(32) default null,
description	text default null,				-- about me
is_active	int not null,						-- default: 1
sid			varchar(64) default null,		-- SESSION ID !!!!!
primary key (aid),
index (name, email, www, rank),
unique (sid)
);

CREATE TABLE `config` (
registration			int not null,				-- 0/1. default is 1: enabled
page_contribute		int not null,				-- minimum user rank (default: 1:user). option: 0: guest, 1: user, 2: editor, 3:admin   -- if set to '-1' then story contribution feature is disabled
topic_contribute		int not null,				-- minimum user rank (default: 1:user). option: 0: guest, 1: user, 2: editor, 3:admin   -- if set to '-1' then story contribution feature is disabled
comment_contribute	int not null,				-- default: 1:guest:  (0-3).	-- if set to '-1' then commenting feature is disabled
topic_view_max		int not null,
topic_chars_view_max	int not null,
comment_max		int not null,
comment_chars_max	int not null,
comment_view_max	int not null
);

CREATE TABLE `node` (
nid			bigint unsigned auto_increment not null,
nodename	varchar(32) not null,
weight		int default 0 not null,
imageurl		varchar(750) default null,			-- no html filter, just quotemeta(), content can be flash or jpeg/gif
primary key (nid),
index (nodename)
);


CREATE TABLE `topic` (
tid			bigint unsigned auto_increment not null,
nid			bigint unsigned not null,
aid			bigint unsigned default 0,			-- (aid = 0 or NULL) is GUEST
title			varchar(128) not null,
description	text default null,
imageurl		varchar(750) default null,			-- no html filter, just quotemeta(), content can be flash or jpeg/gif
tdate		varchar(10) not null,
is_locked	int not null,
publish		int not null,					-- default: 1
total_comment	int default 0,
ip_address	varchar(15) default null,
primary key (tid),
index (nid, aid)
);


CREATE TABLE `comment` (
cid			bigint unsigned auto_increment not null,
tid			bigint unsigned not null,
aid			bigint unsigned default 0,			-- (aid = 0) is GUEST / else IS REGISTERED >= 1
is_guest		int not null,						-- 0/1
guestname	varchar(16) default null,		-- IF guest only !!  /  else NULL
guestemail	varchar(64) default null,		-- IF guest only !!  /   else NULL
guestwww	varchar(32) default null,		-- IF guest only !!  /  else NULL
description	text default null,
cdate		varchar(10) default null,
ip_address	varchar(15) default null,
primary key (cid),
index (tid, aid, ip_address)
);



INSERT INTO `author` (name, rank, password, email, is_active, www) VALUES ('DJ LocalHost', 3, 'a', 'dns@cpan.org', 1, 'http://www.anti-php.net/');
INSERT INTO `author` (name, rank, password, email, is_active, www) VALUES ('Einstein Jr.', 1, 'a', 'dns@jadul.org', 1, 'http://www.jadul.org/');


INSERT INTO `config` (registration, page_contribute, topic_contribute, comment_contribute, topic_view_max, topic_chars_view_max, comment_max, comment_chars_max, comment_view_max) 
			VALUES (1, 2, 1, 0, 12, 1350, 150, 512, 150);


INSERT INTO `node` (nodename, weight)
			VALUES ('Interviews', -5);










