// $Id: strings.js,v 1.5.10.1 2007/08/28 22:48:22 dchen Exp $

if(!Cookie) {
    var Cookie = {};
    Cookie.get = function (key) { var value = document.cookie.match("(?:^|;)\\s*" + key + "=([^;]*)"); return value ? decodeURIComponent(value[1]) : false; }
}

var Locale = {
    DEFAULT : 'en-US',
    getLocale : function() {
        try {
            var curLoc = Cookie.get('locale');
        } catch(e) {
            return 'en-US';    
        }
        return (!curLoc) ? Locale.DEFAULT : curLoc;
    },
    getString : function(name, locale) {
        try {
            if(!locale) var locale = Locale.getLocale();
            return (!Locale[locale]) 
                ? ((!Locale['en-US'][name]) ? '' : Locale['en-US'][name])
                : ((!Locale[locale][name]) ? '' : Locale[locale][name]);
        } catch(e) {
            return '';
        }
    }
}

Locale['en-US'] = {
    'tryAgain' : 'Error. Please try again later.',
    'plsWait' : 'Please wait...',
    //comments and rating
    'loading' : 'loading',
    'fetchingComments': 'fetching comments',
    'noComments' : 'No Comments.',
    'tempUnavail' : 'temporarily unavailable.',
    'seeAllComments' : 'See All Comments',
    'deleteComment' : 'Delete Comment',
    'blockUser' : 'Block this User',
    'commentPosted' : 'posted',
    
    'alreadyCommented' : 'You have commented on this photo.',
    'disabledComments' : 'The owner of this photo has disabled comments.',
    'login2Comment' : 'You have to login to comment on this photo.',
    'cannotComment' : 'You cannot comment on this photo.',
    'first2rate' : 'be the first to rate!',
    'fetchingRating' : 'fetching rating',
    'ratings' : 'ratings',//plural
    'rating' : 'rating',
    'ratingSubmitted' : 'Your rating has been submitted.',
    'alreadyRated' : 'You have rated this photo.',
    'login2rate' : 'You have to login to rate this photo.',
    'cannotRate' : 'You cannot rate this photo.',
    'disabledRating' : 'The owner of this photo has disabled ratings.',
    'editTitle' : 'Click here to edit title',
    'primaryPhoto' : 'Primary Photo',
    'setPrimaryPhoto' : 'Set As Primary Photo',
    'uploadedBy' : 'Uploaded By',
    'grabbedFrom' : 'Grabbed from',
    'shareProfile' : 'Share this profile',
    //location.js
    'selectCity' : 'Select City',
    'selectState' : 'Select State/Province',
    //footer.js
    'sponsorLinks' : 'Sponsored Links',
    'haveBlog' : 'Do you have a blog?',
    'haveRss' : 'Do you have a favorite RSS feed?',
    'showFriends' : 'Would you like to show it to your friends?',
    'enterRss1' : 'Get started by entering the ',
    'enterRss2' : 'RSS field in your profile.',
    'errorRss1' : 'We are not able to process the RSS feed URL you specified in your profile.  Please ',
    'errorRss2' : 'check the URL',
    'errorRss3' : ' for accuracy.  For more information on RSS feeds, please ',
    'errorRss4' : 'read this.',
    'blog' : 'Blog',
    'viewBlog' : 'View Blog',
    'help' : 'Help',
    'recentPost' : 'Recent Posts',
    'seeAllPost' : 'see all posts',
    'posted' : 'Posted',
    //friendster_v1.js
    'smon' : 'Mon',
    'stue' : 'Tue',
    'swed' : 'Wed',
    'sthu' : 'Thu',
    'sfri' : 'Fri',
    'ssat' : 'Sat',
    'ssun' : 'Sun',
    'lmon' : 'Monday',
    'ltue' : 'Tuesday',
    'lwed' : 'Wednesday',
    'lthu' : 'Thursday',
    'lfri' : 'Friday',
    'lsat' : 'Saturday',
    'lsun' : 'Sunday',
    'ljan' : 'January',
    'lfeb' : 'February',
    'lmar' : 'March',
    'lapr' : 'April',
    'lmay' : 'May',
    'ljun' : 'June',
    'ljul' : 'July',
    'laug' : 'August',
    'lsep' : 'September',
    'loct' : 'October',
    'lnov' : 'November',
    'ldec' : 'December',
    'sjan' : 'Jan',
    'sfeb' : 'Feb',
    'smar' : 'Mar',
    'sapr' : 'Apr',
    'smay' : 'May',
    'sjun' : 'Jun',
    'sjul' : 'Jul',
    'saug' : 'Aug',
    'ssep' : 'Sep',
    'soct' : 'Oct',
    'snov' : 'Nov',
    'sdec' : 'Dec',
    //home.js
    'single' : 'Single',
    'inARel' : 'In a Relationship',
    'married' : 'Married',
    'domPar' : 'Domestic Partnership',
    'complicated' : 'It\'s Complicated',
    'featureTempUnavail' : 'This feature is temporarily unavailable. Try checking back in a couple of minutes.',
    //invite.js
    'alreadyInFriendster' : 'are already on Friendster.',
    'seeWhoYouKnow' : 'See who you know.',
    'peopleFrom' : 'people from',
    //modules_friendster.js
    'noContent' : 'No content found.',
    //pandora.js
    'radioTopShared' : 'Top Shared Stations ',
    'viewMore' : 'view more',
    'myStations' : 'My Stations',
    'stationPossesive' : '\'s Stations',
    'details' : 'Details',
    'buyOnAmazon' : 'Buy on Amazon',
    'buyOniTunes' : 'Buy on iTunes',
    'latestFavSong' : 'Latest Favorite Songs',
    //school.js
    // :TODO:
    // 'Error! Not enough function arguments (<number>, excluding the string)\nfor the number of substitution parameters in string (<number> so far).'
    // 'Error! Not enough function arguments (' + (arguments.length - 1) + ', excluding the string)\nfor the number of substitution parameters in string (' + numSubstitutions + ' so far).'
    'selectCountry' : 'Select your country',
    //topfriends.js
    'removeFrmList' : 'Remove from list.',
    'featuredFriendFull' : 'All Featured Friends slots are taken.  Remove one from the list to add a new friend.',
    'featuredFriendAdd' : 'Add to list.',
    //videos.js
    'checkOut' : 'Check this out on Friendster!',
    'loadingVideos' : 'Loading videos...',
    'problemloadingVids' : 'A problem may have occured while loading the videos...  Please try again.',
    'uploadUrOwnVids' : 'Upload Your Own Video',
    'moreVidsOn' : ' More Videos on '
    
};






