#!perl -w
#!/usr/bin/perl -wT



package MetalDoc;

use CGI qw(escapeHTML);
use autouse 'CGI::Carp' => 'fatalsToBrowser';
use autouse 'Digest::SHA1' => qw/sha1_hex($)/;
#use Digest::SHA1 qw/sha1_hex/;
#use autouse 'Mime::Base64';
use Template;
use DBI;
use CGI::Cookie;

use strict;

our $VERSION = '0.0.1-alpha';
our ($SITE_TITLE, $SITE, $ADMIN_EMAIL, $SCRIPT, $USE_MODPERL, $Display);
our ($SCRIPT_ABS_DIR, $SKIN_REL_DIR, $SKIN_ABS_DIR);

# CONFIGURATION

$SITE_TITLE = 'MetalDoc';
$SITE = 'http://localhost/1KRACK/'; 		# must including trailing slash !   # leave blank if you want relative path
$ADMIN_EMAIL = 'admin@metaldoc.com';		# your email
$SCRIPT = 'webscr';							# script name, default: webscr.cgi / index.cgi (leave blank if your script is an index page)
$CGI::POST_MAX = 1024 * 50;				# max 50K posts
$CGI::DISABLE_UPLOADS = 1;					# no uploads
$USE_MODPERL = 0;							# 0: CGI,  1: PerlEx, 2: mod_perl

$SCRIPT_ABS_DIR = 'C:/www/1KRACK/';		# include trailing slash
$SKIN_REL_DIR = "themes/patternSkin/";			# include trailing slash (DON'T CHANGE, UNLESS YOU'RE KNOW WHAT YOU'RE DOING!)

#$SKIN_ABS_DIR = $SCRIPT_ABS_DIR . $SKIN_REL_DIR;			# deprecated
$ENV{SERVER_ADMIN} = $ADMIN_EMAIL;		# heh, heh

# END OF CONFIGURATION



sub new {
	my $class = shift;
	my %new = @_;
	my $self = {
			'_dbh'		=> DBI->connect("DBI:mysql:metaldoc:localhost:3306", "root", "dgdgdg"),
			'_cgi'		=> CGI->new,
			'_tt'		=> Template->new(	'INCLUDE_PATH' => [$SKIN_REL_DIR, $SKIN_REL_DIR . '/admin'],
											#'COMPILE_DIR' => $new{-skindir} . '/temp',
											#'COMPILE_EXT' => '.ttc',
											#'CACHE_SIZE' => 64,			# only cache 64 compiled templates
											'EVAL_PERL' => 0),
			'skindir'	=> $SKIN_REL_DIR,
			'author'	=> undef,			# author.[aid name www email]
			'cookie'	=> undef,
			'page'		=> undef,			# set page to be viewed
			'config'	=> undef,
			'misc'		=> undef,			# page, status, login status,		# $self->{misc}{abc}
			'load_node'	=> undef,			# load_node()
			'data'		=> undef,			# load_node()
			'topic'		=> undef,
			'temp_topic'		=> undef,
			'temp_page'		=> undef,
			'status'	=> undef,
			'param'		=> undef,
			'comment'	=> undef,
			};
	return bless $self, $class;
}



DESTROY {
	my $self = shift;
	CGI::initialize_globals;
	$self->{_dbh}->disconnect;
	#undef %$self;
}



##### INITIALIZATION #####

sub init {
	my $self = shift;
	chdir $SCRIPT_ABS_DIR;			# MOD_PERL need to chdir()
	$self->date_time;
	$self->load_config;
	$self->load_node;				# is this needed for MetalDoc::init() ?
	$self->get_cookie;
	$self->is_logged;
	$self->{param} = $self->{_cgi}->Vars;
	for my $i (keys %{$self->{param}}) {
		$self->{param}{$i} = $self->{_dbh}->quote($self->{param}{$i});
		$self->{param}{$i} =~ s/^'//g;
		$self->{param}{$i} =~ s/'$//g;
		if ($i =~ m/(nid|tid|aid|cid|pid)/) {
			$self->die('Cracking attempt!') if ($self->{param}{$1} =~ m/\D/);		# SQL erection... bleh :-P
		}
	}
	$self->{misc}{site} = $SITE;
	$self->{misc}{site_title} = $SITE_TITLE;
	$self->{misc}{admin_email} = $ADMIN_EMAIL;
	$self->{misc}{script} = $SCRIPT;
	$self->{misc}{version} = $VERSION;
	$self->{page} = 'view_home.html';				# default: view_home.html
	$MetalDoc::Display = 1;							# display is enabled by default: 1 (DON'T CHANGE UNLESS YOU KNOW WHAT ARE YOU DOING)
	$self->{data}{query_string} = $ENV{QUERY_STRING};
	$self->{config}{use_modperl} = $USE_MODPERL;	# is this needed ?
	#$self->get_modperl;		# is this needed ? . if return 0 mean mod_perl is not used
}


sub load_config {
	my $self = shift;
	my @table = qw/registration topic_contribute comment_contribute topic_view_max topic_chars_view_max comment_max comment_chars_max comment_view_max/;
	my %config;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `config` LIMIT 0, 1");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		for my $t (@table) {
			$config{$t} = $data->{$t};
			$self->{config}{$t} = $data->{$t};
		}
		last;
	}
}


sub load_node {
	my $self = shift;
	my @table = qw/nid nodename weight imageurl/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `node` ORDER BY `weight` DESC");
	$sth->execute;
	my $j = 0;
	while (my $data = $sth->fetchrow_hashref) {
		for my $i (@table) {
			$self->{'load_node'}[$j]{$i} = $data->{$i};
			$self->{data}{node}[  $data->{nid}  ] = $data->{nodename};
		}
		$j++;
	}
}


sub get_modperl {
	my $self = shift;
	my $MOD_PERL = 0;
	if (exists $ENV{MOD_PERL}) {
		if (exists $ENV{MOD_PERL_API_VERSION} && $ENV{MOD_PERL_API_VERSION} == 2) {
			$MOD_PERL = 2;
			require Apache2::RequestUtil;
			require APR::Table;
		} else {
			$MOD_PERL = 1;
			require Apache;
		}
	}
	$self->{config}{modperl_version} = $MOD_PERL;
	return $MOD_PERL;
#PERLHOST="PerlEx"
#PERLXS="PerlEx"
#GATEWAY_INTERFACE="CGI-PerlEx"
#SERVER_SOFTWARE=Microsoft-IIS/5.1
}

sub get_cookie {
	my $self = shift;
	my ($raw_cookie, $key, $value, %results);

	$raw_cookie = $ENV{HTTP_COOKIE};	# || $ENV{COOKIE};
	if (defined $raw_cookie) {
		my (@pairs) = split('; ', $raw_cookie);
		for my $i (@pairs) {
			$i =~ s/\s*(.*?)\s*/$1/;
			if ($i =~ /^([^=]+)=(.*)/) {
				$key = $1;
				$value = $2;
			} else {
				$key = $i;
				$value = undef;
			}
			$self->{cookie}{$key} = $value;
		}
	} else {
		undef $self->{cookie};
	}
}

sub is_logged {
	my $self = shift;
	my $db_sid;
	if (defined $self->{cookie}{md} and $self->{cookie}{md} ne '') {
		my ($cookie_sid, $aid) = split('u', $self->{cookie}{md});
		$self->{misc}{aid} = $aid;
		my $sth = $self->{_dbh}->prepare("SELECT `sid` FROM `author` WHERE `aid` = $aid LIMIT 0, 1");
		$sth->execute;
		while (my $data = $sth->fetchrow_hashref) {
			$db_sid = $data->{sid};
			last;
		}
		if ($self->{cookie}{md} eq $db_sid) {
			$self->{misc}{is_logged} = 1;
			$self->{misc}{sid} = $db_sid;					# export to misc.
			$self->fetch_author($aid);						# fetch user name, email, www, rank
			$self->{misc}{rank} = $self->{author}{$aid}{rank};		# set current user rank
		} else {
			$self->{misc}{is_logged} = 0;
			$self->{misc}{rank} = 0;				# guest
		}
	} else {
		$self->{misc}{is_logged} = 0;
		$self->{misc}{rank} = 0;				# guest
	}
	return 0;
}

sub fetch_author {
	my $self = shift;
	my $aid = $_[0];
	$self->{author}{$aid}{aid} = $aid;
	if (defined $aid) {
		my @table = qw/name email rank www/;
		my $sth = $self->{_dbh}->prepare("SELECT `name`,`email`,`rank`,`www` FROM `author` WHERE `aid` = $aid");	# LIMIT 0, 1
		$sth->execute;

		while (my $data = $sth->fetchrow_hashref) {
			for my $i (@table) {
				$self->{author}{$aid}{$i} = $data->{$i};
			}
			last;
		}
	}
}

sub create_cookie {
	my $self = shift;
	my $random = sha1_hex(int(rand(9999)));
	$self->die('$aid is not defined') unless $self->{misc}{aid};
	$self->{misc}{sid} = $random . 'u' . $self->{misc}{aid};
	my $new_cookie = CGI::Cookie->new(	-name=> 'md',
										-value=> $self->{misc}{sid},
										-expires => '+3h',
									);
	$self->{misc}{cookie_object} = $new_cookie;
	return 1;
}

##### ADMIN ACCESS #####

sub view::admin {
	my $self = shift;
	$self->registered_only_page;
	$self->{misc}{page_title} = 'Administrators Control Panel ~ ' . $SITE_TITLE;
	if ($self->{misc}{rank} == 3) {		# admin only rank -> 3
		$self->{page} = 'view_admin.html';
	} else {
		$self->die("Only administrators can view this page!");
	}
}

sub view::editor {
	my $self = shift;
	my $aid = $self->{misc}{aid};
	$self->registered_only_page;
	$self->{page} = 'view_editor.html';
	if ($self->{misc}{rank} >= 2) {			# admin access
		my @table = qw/title description imageurl nid aid tdate ip_address/;
		my $sth = $self->{_dbh}->prepare("SELECT * FROM `temp_topic` LIMIT 0, 15");
		$sth->execute;
		my $j = 0;
		while (my $data = $sth->fetchrow_hashref) {
			for my $i (@table) {
				$self->{temp_topic}[$j]{$i} = $data->{$i};
			}
			$j++;
			$self->fetch_author($data->{aid});
		}
		
		my @table2 = qw/krack_id title description aid pdate ip_address/;
		my $sth2 = $self->{_dbh}->prepare("SELECT * FROM `temp_page` LIMIT 0, 15");
		$sth2->execute;
		my $j2 = 0;
		while (my $data = $sth2->fetchrow_hashref) {
			for my $i2 (@table2) {
				$self->{temp_page}[$j2]{$i2} = $data->{$i2};
			}
			$j2++;
			$self->fetch_author($data->{aid});
		}
	} else {
		$self->die("Only editors can view this page!");
	}
}

sub view::editor::temptopic {
	my $self = shift;
	my $aid = $self->{misc}{aid};
	$self->registered_only_page;
	$self->{page} = 'view_editor_temptopic.html';
	if ($self->{misc}{rank} >= 2) {			# admin access
		my @table = qw/title description imageurl nid aid tdate ip_address/;
		my $sth = $self->{_dbh}->prepare("SELECT * FROM `temp_topic` WHERE `title` = '$self->{param}{original_title}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 0, 1");
		$sth->execute;
		my $j = 0;
		while (my $data = $sth->fetchrow_hashref) {
			for my $i (@table) {
				$self->{temp_topic}[$j]{$i} = $data->{$i};
			}
			#$j++;
			$self->fetch_author($data->{aid});
			last;
		}
	} else {
		$self->die("Only editors can view this page!");
	}
}

sub view::editor::temppage {
	my $self = shift;
	my $aid = $self->{misc}{aid};
	$self->registered_only_page;
	$self->{page} = 'view_editor_temppage.html';
	if ($self->{misc}{rank} >= 2) {			# admin access
		my @table = qw/krack_id title description aid pdate ip_address/;
		my $sth = $self->{_dbh}->prepare("SELECT * FROM `temp_page` WHERE `krack_id` = '$self->{param}{original_id}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 0, 1");
		$sth->execute;
		my $j = 0;
		while (my $data = $sth->fetchrow_hashref) {
			for my $i (@table) {
				$self->{temp_page}[$j]{$i} = $data->{$i};
			}
			#$j++;
			$self->fetch_author($data->{aid});
			last;
		}
	} else {
		$self->die("Only editors can view this page!");
	}
}

#### NEW::*
# cid tid aid is_guest guestname guestemail guestwww comment_title description cdate ip_address
# cid, tid, aid, is_guest, guestname, guestemail, guestwww, comment_title, description, cdate, ip_address
sub new::comment {
	my $self = shift;
	my $ip_address = $ENV{REMOTE_ADDR};

	my ($year, $month, $date);
	$year = $self->{misc}{'datetime'}[5];
	$month = $self->{misc}{'datetime'}[4];
	$date = $self->{misc}{'datetime'}[3];
	my $cdate = "$date/$month/$year";

	my $total_comment;
	my $sth = $self->{_dbh}->prepare("SELECT `total_comment` FROM `topic` WHERE `tid` = $self->{param}{tid} LIMIT 0, 1");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		$total_comment = $data->{total_comment};
		last;
	}
	#$self->die($total_comment);
	$total_comment++;

	$self->{_dbh}->do("UPDATE LOW_PRIORITY `topic` SET `total_comment` = $total_comment WHERE `tid` = $self->{param}{tid} LIMIT 1");


	# cgi.param -> name, www, email, comment
	if ($self->{misc}{is_logged} == 0) {			# guest
		if (	$self->{param}{name} and
			$self->{param}{email} and
			($self->{config}{comment_contribute} <= $self->{misc}{rank}) and
			$self->{param}{tid} and
			length($self->{param}{comment}) >= 9 ) {		# too few chars to post comment, need more chars
			($self->{param}{www} = 'NULL') unless $self->{param}{www};
			# TODO
			if ($self->{config}{comment_chars_max} != 0) {
				$self->{param}{comment} = substr $self->{param}{comment}, 0, $self->{config}{comment_chars_max};
			}
			$self->{_dbh}->do("
				INSERT INTO `comment` (tid, aid, is_guest, guestname, guestemail, guestwww, description, cdate, ip_address)
				VALUES ('$self->{param}{tid}', 0, 1, '$self->{param}{name}', '$self->{param}{email}', '$self->{param}{www}', '$self->{param}{comment}', '$cdate', '$ip_address' )
			");
			$MetalDoc::Display = 0;
			print $self->{_cgi}->redirect($SITE . $SCRIPT . "?cmd=view;q=topic;tid=" . $self->{param}{tid});
		} else {
			$self->die("You must enter something in comment field");
		}
	} else {		# registered users
		if (	$self->{param}{tid} and
			($self->{config}{comment_contribute} <= $self->{misc}{rank}) and
			length($self->{param}{comment}) >= 9 ) {
			if ($self->{config}{comment_chars_max} != 0) {
				if ($self->{misc}{rank} < 2) {			# 2-3: Editor &Admin rank can post as many as they like !
					$self->{param}{comment} = substr $self->{param}{comment}, 0, $self->{config}{comment_chars_max};
				}
			}
			$self->{_dbh}->do("
				INSERT INTO `comment` (tid, aid, is_guest, guestname, guestemail, guestwww, description, cdate, ip_address)
				VALUES ('$self->{param}{tid}', $self->{misc}{aid}, 0, NULL, NULL, NULL, '$self->{param}{comment}', '$cdate', '$ip_address' )
			");
			$MetalDoc::Display = 0;
			print $self->{_cgi}->redirect($SITE . $SCRIPT . "?cmd=view;q=topic;tid=" . $self->{param}{tid});
		} else {
			$self->die("You must enter something in comment field");
		}
	}
	#$self->{param}{}
}


sub new::topic {
	my $self = shift;

	my ($year, $month, $date);
	$year = $self->{misc}{'datetime'}[5];
	$month = $self->{misc}{'datetime'}[4];
	$date = $self->{misc}{'datetime'}[3];

	my $tdate = "$date/$month/$year";

	if ($self->{param}{'accept'} == 1) {
		my @table_topic = qw/tid nid aid title description tdate is_locked publish ip_address/;
		$self->{_dbh}->do("
			INSERT INTO `topic` (nid, aid, title, description, tdate, is_locked, publish, ip_address, imageurl, total_comment)
			VALUES ('$self->{param}{nid}', '$self->{param}{poster_aid}', '$self->{param}{title}', '$self->{param}{description}', '$tdate', $self->{param}{is_locked}, $self->{param}{publish}, '$self->{param}{ip_address}', '$self->{param}{imageurl}', 0 )
		");
		# TODO: DELETE temp_topic WHERE `title` = '$original_title'
		$self->{_dbh}->do("DELETE LOW_PRIORITY FROM `temp_topic` WHERE `title` = '$self->{param}{original_title}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 1");
		$MetalDoc::Display = 0;
		print $self->{_cgi}->redirect($SITE . $SCRIPT);
	} else {
		$self->{_dbh}->do("DELETE LOW_PRIORITY FROM `temp_topic` WHERE `title` = '$self->{param}{original_title}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 1");
		#$self->die('topic has been deleted');
	}
	$self->view::editor;
}

# TODO:  NEW PAGE
sub new::page {
	my $self = shift;
	my ($year, $month, $date);
	$year = $self->{misc}{'datetime'}[5];
	$month = $self->{misc}{'datetime'}[4];
	$date = $self->{misc}{'datetime'}[3];
	my $pdate = "$date/$month/$year";
	if ($self->{param}{'accept'} == 1) {
		#my @table_topic = qw/pid krack_id aid title description pdate is_locked total_comment ip_address/;
		$self->{_dbh}->do("
			INSERT INTO `page` (krack_id, aid, title, description, pdate, is_locked, ip_address, total_comment)
			VALUES ('$self->{param}{krack_id}', '$self->{param}{poster_aid}', '$self->{param}{title}', '$self->{param}{description}', '$pdate', $self->{param}{is_locked}, '$self->{param}{ip_address}', 0 )
		");
		# TODO: DELETE temp_topic WHERE `title` = '$original_title'
		$self->{_dbh}->do("DELETE LOW_PRIORITY FROM `temp_page` WHERE `krack_id` = '$self->{param}{original_id}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 1");
		$MetalDoc::Display = 0;
		print $self->{_cgi}->redirect($SITE . $SCRIPT);
	} else {
		$self->{_dbh}->do("DELETE LOW_PRIORITY FROM `temp_page` WHERE `krack_id` = '$self->{param}{original_id}' AND `aid` = '$self->{param}{poster_aid}' LIMIT 1");
		#$self->die('topic has been deleted');
	}
	$self->view::editor;
}


sub new::temptopic {
	my $self = shift;
	$self->registered_only_page;
	if ($self->{config}{topic_contribute} <= $self->{misc}{rank}) {
		my $aid = $self->{misc}{aid};					# duplicated again :-)
		my $ip_address = $ENV{REMOTE_ADDR};			# get client ip address

		my ($year, $month, $date);
		$year = $self->{misc}{'datetime'}[5];
		$month = $self->{misc}{'datetime'}[4];
		$date = $self->{misc}{'datetime'}[3];
		my $tdate = "$date/$month/$year";		# need quote

		$self->{_dbh}->do("
			INSERT INTO `temp_topic` (`title`, `description`, `nid`, `aid`, `tdate`, `ip_address`, `imageurl`)
			VALUES ('$self->{param}{title}', '$self->{param}{description}', $self->{param}{nid}, $aid, '$tdate', '$ip_address', '$self->{param}{imageurl}' )
		");

		$MetalDoc::Display = 0;
		print $self->{_cgi}->redirect($SITE . $SCRIPT);
	} else {
		$self->die('story contribution is disabled');
	}
}


sub new::temppage {
	my $self = shift;
	$self->registered_only_page;
	if ($self->{config}{topic_contribute} <= $self->{misc}{rank}) {
		my $aid = $self->{misc}{aid};					# duplicated again :-)
		my $ip_address = $ENV{REMOTE_ADDR};			# get client ip address

		my ($year, $month, $date);
		$year = $self->{misc}{'datetime'}[5];
		$month = $self->{misc}{'datetime'}[4];
		$date = $self->{misc}{'datetime'}[3];
		my $pdate = "$date/$month/$year";		# need quote

		$self->{_dbh}->do("
			INSERT INTO `temp_page` (`krack_id`, `title`, `description`, `aid`, `pdate`, `ip_address` )
			VALUES ('$self->{param}{krack_id}', '$self->{param}{title}', '$self->{param}{description}', $aid, '$pdate', '$ip_address' )
		");

		$MetalDoc::Display = 0;
		print $self->{_cgi}->redirect($SITE . $SCRIPT);
	} else {
		$self->die('story contribution is disabled');
	}
}

sub new::node {
	my $self = shift;

	$self->registered_only_page;
	$MetalDoc::Display = 0;		# not show !

	if ($self->{misc}{rank} == 3) {		# admin only !
		$self->{_dbh}->do("
			INSERT INTO `node` (`nodename`, `weight`, `imageurl`)
			VALUES ('$self->{param}{nodename}', $self->{param}{weight}, '$self->{param}{imageurl}' )
		");
		print $self->{_cgi}->redirect( $SITE . $SCRIPT . '?cmd=view;q=admin');
	} else {
		$self->die("You are not authorized to view this page.");
	}
}

sub del::node {
	my $self = shift;
}

sub del::topic {
	my $self = shift;
}





# USER / CMD

sub register {					# temporary user !!!!!!!!!!!!
	my $self = shift;
	
	my $confirm_code = sha1_hex(int(rand(99)));
	
	if ($self->{config}{registration} == 1) {
		if (($self->{param}{password} eq $self->{param}{repassword}) and (length($self->{param}{password}) <= 15) and (length($self->{param}{password}) >= 1) and ($self->{param}{password} !~ m/[\W]/ )) {
			# DONE: check is requested email is exist or not
			my $sth = $self->{_dbh}->prepare("SELECT `email` FROM `author` WHERE `email` = '$self->{param}{email}' LIMIT 0, 1");
			$sth->execute;
			while (my $data = $sth->fetchrow_hashref) {
				if ($self->{param}{email} eq $data->{email}) {
					$self->die("Email address is exist!\nPlease choose your different email address.");
				}
				last;
			}
			my $sth2 = $self->{_dbh}->prepare("SELECT `email` FROM `temp_author` WHERE `email` = '$self->{param}{email}' LIMIT 0, 1");
			$sth2->execute;
			while (my $data2 = $sth2->fetchrow_hashref) {
				if ($self->{param}{email} eq $data2->{email}){
					$self->die("Email address is exist!\nPlease choose your different email address.");
				}
				last;
			}
			
			$self->{param}{name} = escapeHTML($self->{param}{name});
			$self->{param}{email} = escapeHTML($self->{param}{email});
			$self->{param}{www} = escapeHTML($self->{param}{www});
			$self->{param}{country} = escapeHTML($self->{param}{country});
			
			$self->{_dbh}->do("
				INSERT INTO `temp_author` (`name`, `email`, `password`, `www`, `country`, `confirm_code`)
				VALUES ('$self->{param}{name}', '$self->{param}{email}', '$self->{param}{password}', '$self->{param}{www}', '$self->{param}{country}', '$confirm_code' )
			");
			# SEND EMAIL TO $email
			$self->sendmail($self->{param}{email}, $self->{param}{name}, $self->{param}{password}, $confirm_code);
			$self->{page} = 'view_confirmcode.html';
		} else {
			$self->die("Password doesn't match. \nPassword need : 1 < characters < 15.\nAllowed password character is [0-9a-zA-Z_]");
		}
	} else {
		$self->die('Registration disabled. Please come back later.');
	}
}

sub confirm {					# real user !!!!!!!!!!!!!!!!
	my $self = shift;
	my ($name, $email, $password);
	#my $confirm_code = $self->{_cgi}->param('c');	# confirmation code  # don't need to quote !!
	my $code_match = 0;
	
	#$email = $self->{_cgi}->param('email');		# EMAIL  # need quote
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `temp_author` WHERE `email` = '$self->{param}{email}' LIMIT 0, 1");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		if ($data->{confirm_code} eq $self->{param}{'c'}) {
			$code_match = 1;
			$email = $data->{email};             # set $email again ???
			$password = $data->{password};
			$name = $data->{name};
		} else {
			$code_match = 0;
		}
		last;
	}
	
	if ($code_match == 1) {
		$self->{_dbh}->do("DELETE LOW PRIORITY FROM `temp_author` WHERE `email` = '$self->{param}{email}' ");
		$self->{_dbh}->do("
		INSERT INTO `author` (`name`, `email`, `rank`, `password`)
		VALUES ('$self->{param}{name}', '$self->{param}{email}', 1, '$self->{param}{password}' );
		");
		$self->{page} = 'view_verified_author.html';
	} else {
		$self->die("Wrong verification code!");
	}
}


sub login {
	my $self = shift;
	#cgi.param: name password
	my @table = qw/aid password is_active sid/;
	my %fetch;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `author` WHERE `email` = '$self->{param}{email}' LIMIT 0, 1");
	$sth->execute;

	while (my $data = $sth->fetchrow_hashref) {
		for my $i(@table) {
			$fetch{$i} = $data->{$i};
		}
		last;
	}
	my $aid = $fetch{aid};		# :-)

	if (($self->{param}{password} eq $fetch{password}) && ($fetch{is_active} != 0) ) {
		$self->{misc}{aid} = $aid;
		$self->{misc}{is_logged} = 1;
		$self->fetch_author($aid);
		$self->{misc}{rank} = $self->{author}{$aid}{rank};		# set current user rank
	} else {
		$self->die('invalid email or password, or user is inactive');			# error page
	}

	if ($self->create_cookie == 1) {
		my $sid = $self->{misc}{sid};
		$self->{_dbh}->do("UPDATE LOW_PRIORITY `author` SET `sid` = '$sid' WHERE `aid` = $aid");
	}

	$self->view::home;		# view home after login # if failed view error page
}


### VIEW ###

sub view::newtemptopic {
	my $self = shift;
	$self->registered_only_page;
	if ($self->{config}{topic_contribute} <= $self->{misc}{rank}) {
		$self->{page} = 'view_newtemptopic.html';
	} else {
		$self->die('page contribution is disabled');
	}
}

sub view::newpage {
	my $self = shift;
	$self->registered_only_page;
	if ($self->{config}{page_contribute} <= $self->{misc}{rank}) {
		$self->{page} = 'view_newpage.html';
	} else {
		$self->die('page contribution is disabled');
	}
}

sub view::register {
	my $self = shift;
	$self->guest_only_page;
	if ($self->{config}{registration} == 1) {
		$self->{misc}{page_title} = 'Registration Page ~ ' . $SITE_TITLE;
		$self->{page} = 'view_register.html';
	} else {
		$self->die('Registration disabled. Please come back later.');
	}
}


sub view::login {
	my $self = shift;
	$self->{page} = 'view_login.html';
	$self->{misc}{page_title} = 'Login Page ~ ' . $SITE_TITLE;
	$self->guest_only_page;
}

sub logout {
	my $self = shift;
	my $aid = $self->{misc}{aid};
	$MetalDoc::Display = 0;
	#$self->registered_only_page;			# deprecated !
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `author` SET `sid` = NULL WHERE `aid` = $aid");
	print $self->{_cgi}->redirect($SITE . $SCRIPT);
}


# VIEW_*
sub view::home {
	my $self = shift;
	$self->{page} = 'view_home.html';
	$self->{misc}{page_title} = 'Home ~ ' . $SITE_TITLE;

	my $start = 0;
	$self->{misc}{this_page} = 0;
	if (defined($self->{param}{'p'}) and ($self->{_cgi}->param('p') >= 0)) {
		$start = $self->{param}{'p'};
		$self->{misc}{this_page} = $start;
	}
	my $end = $start + $self->{config}{topic_view_max};
	my @table = qw/tid nid aid title description imageurl tdate is_locked publish total_comment/;

	my $sth = $self->{_dbh}->prepare("SELECT * FROM `topic` WHERE `publish` = 1 ORDER BY `tid` DESC LIMIT $start, $end");
	$sth->execute;

	my $j = 0;
	while (my $data = $sth->fetchrow_hashref) {
		for my $i (@table) {
			$self->{topic}[$j]{$i} = $data->{$i};
			if ($i eq 'description') {
				if ($self->{config}{topic_chars_view_max} > 0) {
					$self->{topic}[$j]{$i} = substr $self->{topic}[$j]{$i}, 0, $self->{config}{topic_chars_view_max};
				}
				$self->{topic}[$j]{$i} =~ s/  / &nbsp;/g;
				$self->{topic}[$j]{$i} =~ s!\n!<br />\n!g;
			}
		}
		$self->fetch_author($data->{aid});
		$j++;
	}
}

sub view::fpass {			# forgot password
	my $self = shift;
	$self->{page} = 'view_fpass.html';
}

sub view::editprofile {
	my $self = shift;
	$self->registered_only_page;
	$self->{page} = 'view_editprofile.html';
	my @table = qw/aid name email rank editor_node password www date_joined birth_date location country description/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `author` WHERE `aid` = $self->{misc}{aid} LIMIT 0, 1");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		for my $i (@table) {
			$self->{data}{author}{$i} = $data->{$i};
		}
		last;
	}
}

sub view::profile {
	my $self = shift;
	$self->fetch_author($self->{param}{aid}) if $self->{param}{aid};
	my $sth = $self->{_dbh}->prepare("SELECT `description` FROM `author` WHERE `aid` = $self->{param}{aid} LIMIT 1");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		$self->{author}{ $self->{param}{aid} }{description} = $data->{description};
	}
	$self->{page} = 'view_profile.html';
	$self->{data}{view_profile_aid} = $self->{param}{aid};
}

sub view::node {
	my $self = shift;
	$self->{page} = 'view_node.html';
	my $start = 0;
	$self->{misc}{this_page} = 0;
	if (defined($self->{_cgi}->param('p')) and ($self->{_cgi}->param('p') >= 0)) {
		$start = $self->{_cgi}->param('p');			# param('start_page') replaced with param('p')
		$self->{misc}{this_page} = $start;
	}
	my $end = $start + $self->{config}{topic_view_max};
	my @table = qw/tid nid aid title description imageurl tdate is_locked publish total_comment/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `topic` WHERE `nid` = $self->{param}{nid} ORDER BY `tid` DESC LIMIT $start, $end");
	$sth->execute;

	my $j = 0;
	while (my $data = $sth->fetchrow_hashref) {
		for my $i (@table) {
			# DON'T CHANGE THE ORDER
			$self->{topic}[$j]{$i} = $data->{$i};
			if ($i eq 'description') {
				if ($self->{config}{topic_chars_view_max} > 0) {
					$self->{topic}[$j]{$i} = substr $self->{topic}[$j]{$i}, 0, $self->{config}{topic_chars_view_max};
				}
				#$self->{topic}[$j]{$i} = escapeHTML($self->{topic}[$j]{$i});
				$self->{topic}[$j]{$i} =~ s/  / &nbsp;/g;
				$self->{topic}[$j]{$i} =~ s!\n!<br />\n!g;
			}
		}
		$self->fetch_author($data->{aid});
		$j++;
	}
	$self->{misc}{nid} = $self->{param}{nid};
}


sub view::topic {
	my $self = shift;
	$self->{page} = 'view_topic.html';
	my @table = qw/tid nid aid title description imageurl tdate is_locked publish total_comment/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `topic` WHERE `tid` = $self->{param}{tid} LIMIT 0, 1");
	$sth->execute;

	while (my $data = $sth->fetchrow_hashref) {
		for my $i (@table) {
			# DON'T CHANGE THE ORDER
			$self->{topic}[0]{$i} = $data->{$i};
			if ($i ne 'imageurl') {
				$self->{topic}[0]{$i} = escapeHTML($self->{topic}[0]{$i});
				$self->{topic}[0]{$i} =~ s/  / &nbsp;/g;
				$self->{topic}[0]{$i} =~ s!\n!<br />\n!g;
			}
			$self->fetch_author($data->{aid});
		}
	}

	$self->view::_comment;
	# topic.0.is_locked & config.comment_contribute  !!!!! COMMENTING SYSTEM  !!!
}

# tid, aid, is_guest, guestname, guestemail, guestwww, description, cdate, ip_address
sub view::_comment {					# PRIVATE USE !!. USED BY: view::topic()
	my $self = shift;
	my $start = undef;
	if (defined($self->{param}{'p'}) and ($self->{param}{'p'} >= 0)) {
		$start = $self->{param}{'p'};			# param('start_page') replaced with param('p')
		$self->{misc}{this_page} = $start;
	} else {
		$start = 0;
		$self->{misc}{this_page} = 0;
	}
	my $end = $start + $self->{config}{comment_view_max};
	my @table = qw/cid tid aid is_guest guestname guestemail guestwww description cdate ip_address/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `comment` WHERE `tid` = $self->{param}{tid} ORDER BY `cid` DESC LIMIT $start, $end");
	$sth->execute;
	my $j = 0;
	while (my $data = $sth->fetchrow_hashref) {
		if ($data->{is_guest} == 0) {
			$self->fetch_author($data->{aid});
		}
		for my $i (@table) {
			$self->{comment}[$j]{$i} = $data->{$i};
			$self->{comment}[$j]{$i} = escapeHTML($self->{comment}[$j]{$i});
			if ($i eq 'description') {
				$self->{comment}[$j]{$i} =~ s/  / &nbsp;/g;
				$self->{comment}[$j]{$i} =~ s!\n!<br />\n!g;
			}
		}
		$j++;
	}
}


sub view::page {							# cmd=page;q=PAGEINDEX
	my $self = shift;
	
	# TODO : IMPLEMENT IN TEMPLATE TOOLKIT & CREATE CODE FOR $self->{page}[..]{title/description}
}


# ADMIN ACCESS

sub edit::config {
	my $self = shift;
	my @table = qw/registration topic_contribute comment_contribute topic_view_max topic_chars_view_max comment_max comment_chars_max comment_view_max/;

}


#### USER edit profile & password

sub edit::profile {
	my $self = shift;
	if ($self->{param}{password} and $self->{param}{repassword}) {
		if ($self->{param}{password} eq $self->{param}{repassword}) {
			$self->{_dbh}->do("UPDATE LOW_PRIORITY `author` SET `password` = '$self->{param}{password}' WHERE `aid` = $self->{misc}{aid} LIMIT 1");
		} else {
			$self->die("Password doesn't match");
		}
	}
	my @col = qw/name www location country description/;
	for my $c (@col) {
		$self->{param}{$c} = escapeHTML($self->{param}{$c});
		$self->{_dbh}->do("UPDATE LOW_PRIORITY `author` SET `$c` = '$self->{param}{$c}' WHERE `aid` = $self->{misc}{aid} LIMIT 1");
	}
	# redirect to view::succes_editprofile
	$MetalDoc::Display = 0;
	print $self->{_cgi}->redirect($SITE . $SCRIPT);
}


sub rdf {
	my $self = shift;
	#$self->die('RDF is not implemented yet');
	#$MetalDoc::Display = 0;
	$self->{page} = 'feed.xml';
	my $q = $self->{_cgi}->param('q');
	if ($q eq 'node') {
		$self->view::node;
	}
}

sub jump {
	my $self = shift;
	my $site_jump = $self->{_cgi}->param("jump");
	if ($site_jump !~ m/http:\/\//i) {
		$site_jump = 'http://' . $site_jump;
	}
	print $self->{_cgi}->redirect($site_jump);
	$MetalDoc::Display = 0;
}

sub search {

}

sub display {
	my $self = shift;
	my $vars = {
		skindir	=> $self->{skindir},
		page	=> $self->{page},
		config	=> $self->{config},
		misc	=> $self->{misc},
		author	=> $self->{author},
		topic	=> $self->{topic},
		temp_topic	=> $self->{temp_topic},
		temp_page	=> $self->{temp_page},
		load_node	=> $self->{load_node},
		data	=> $self->{data},
		comment	=> $self->{comment},
	};
	if ($MetalDoc::Display != 0) {
		if (defined $self->{misc}{cookie_object}) {
			print $self->{_cgi}->header(-cookie=>[$self->{misc}{cookie_object}]);
		} else {
			print $self->{_cgi}->header;
		}
		$self->{_tt}->process($self->{page}, $vars) or $self->die($self->{_tt}->error);
	}
}


sub view::video {
	my $self = shift;
	$self->{page} = 'view_video.html';
}

sub guest_only_page {
	my $self = shift;
	if ($self->{misc}{is_logged} == 1) {
		$self->die('You are currently logged in');
	}
}

sub registered_only_page {
	my $self = shift;
	if ($self->{misc}{is_logged} == 0) {
		$self->die('Only registered users can view this page');
	}
}

sub die {						# TODO: replace with better error msg
	my $self = shift;
	$MetalDoc::Display = 0;
	die $_[0], "\n";
}

sub date_time {
	my $self = shift;
	my @time = gmtime;
	$time[5] += 1900;	# year
	$time[4]++;			# month
	#$time[3];			# day
	# 2			# hour
	# 1			# minute
	# 0			# second
	$self->{misc}{'datetime'} = [ $time[0], $time[1], $time[2], $time[3], $time[4], $time[5] ];
	#return $time[5], $time[4], $time[3], $time[2], $time[1], $time[0];
}


sub sendmail {
	my $self = shift;
	my ($email, $aid, $password, $confirm_code);
	open(SENDMAIL, "|/usr/lib/sendmail -oi -t -odq") or $self->die("Can't fork for sendmail: $!");
	print SENDMAIL <<"EOT";
From: $SITE_TITLE Confirmation Code <$ADMIN_EMAIL>
To: $aid <$email>
Subject: $SITE_TITLE Registration Confirmation

Dear $email,

Please confirm your account by visiting (click) this link:

$SITE/$SCRIPT?cmd=confirm;c=$confirm_code;aid=$aid

and then login by using your Login Name and your Password:

Login Name: $aid
Password: $password

Once this is done, your account will be activated, and
you will be able to edit pages in $SITE


EOT
	close(SENDMAIL);

}


sub run {
	my $news = shift;
	if (defined $news->{_cgi}->param) {
		my $q = $news->{_cgi}->param('q');
		if ($news->{_cgi}->param('cmd')) {			# cmd
			my $cmd = $news->{_cgi}->param('cmd');
			if ($cmd eq 'view') {					# cmd=VIEW
				if ($q eq 'login') {
					$news->view::login;				# view login page
				} elsif ($q eq 'node') {
					$news->view::node;					# cmd=node, nid=123
				} elsif ($q eq 'topic') {
					$news->view::topic;
				} elsif ($q eq 'register') {
					$news->view::register;
				} elsif ($q eq 'newtemptopic') {
					$news->view::newtemptopic;			# view contribute story page
				} elsif ($q eq 'author') {				# with cgi.param('aid') / 'id'
					$news->view::aid;
				} elsif ($q eq 'video') {
					$news->view::video;
				} elsif ($q eq 'editprofile') {
					$news->view::editprofile;
				} elsif ($q eq 'profile') {
					$news->view::profile;
				} elsif ($q eq 'newpage') {
					$news->view::newpage;
				} elsif ($q eq 'fpass') {
					$news->view::fpass;				# forgot password page
				} elsif ($q eq 'editor') {
					$news->view::editor;
				} elsif ($q eq 'editor_temptopic') {
					$news->view::editor::temptopic;
				} elsif ($q eq 'editor_temppage') {
					$news->view::editor::temppage;
				} elsif ($q eq 'admin') {
					$news->view::admin;
				} else {
					$news->die("Error: Parameter '$q' is not recognized");
				}
			} elsif ($cmd eq 'login') {				# cmd=LOGIN
				$news->login;
			} elsif ($cmd eq 'logout') {				# cmd=LOGOUT
				$news->logout;
			} elsif ($cmd eq 'edit') {				# cmd=EDIT
				if ($q eq 'profile') {
					$news->edit::profile;
				} elsif ($q eq 'topic') {
					$news->edit::topic;
				} elsif ($q eq 'node') {				# worst case: n = 8
					$news->edit::node;
				} elsif ($q eq 'config') {				# worst case: n = 8
					$news->edit::config;
				} else {
					$news->die("Error: Parameter '$q' is not recognized");
				}
			} elsif ($cmd eq 'delete') {				# cmd=DELETE
				if ($q eq 'comment') {					# with cgi.param('cid')
					$news->del::comment;
				} elsif ($q eq 'topic') {					# with cgi.param('tid')
					$news->del::topic;
				} elsif ($q eq 'node') {					# with cgi.param('tid')
					$news->del::node;
				} elsif ($q eq 'temp_author') {					# with cgi.param('tid')
					$news->del::tempauthor;
				}
			} elsif ($cmd eq 'new') {				# cmd=NEW
				if ($q eq 'comment') {
					$news->new::comment;
				} elsif ($q eq 'temptopic') {
					$news->new::temptopic;
				} elsif ($q eq 'temppage') {
					$news->new::temppage;
				} elsif ($q eq 'topic') {
					$news->new::topic;
				} elsif ($q eq 'page') {
					$news->new::page;
				} elsif ($q eq 'node') {
					$news->new::node;
				}
			} elsif ($cmd eq 'register') {					# new_tempauthor		# cmd=REGISTER
				$news->register;
			} elsif ($cmd eq 'confirm') {					# permanent user ID	# cmd=CONFIRM
				$news->confirm;
			} elsif ($cmd eq 'xml') {						# rss/rdf feed			# cmd=XML		# WORST CASE n = 8
				$news->rdf;
			} else {
				$news->die("Error: Command '$cmd' is not supported");			# custom error page
			}
		} elsif ($news->{_cgi}->param('page')) {			# worst case: n = 2
			$news->view::page;
		} elsif ($news->{_cgi}->param('search')) {			# worst case: n = 3
			if ($q eq 'topic') {
				$news->search::topic;
			} elsif ($q eq 'all') {
				$news->search::all;
			} elsif ($q eq 'comment') {
				$news->search::comment;
			} elsif ($q eq 'page') {
				$news->search::page;
			} else {
				$news->die("Error: Parameter '$q' is not recognized");
			}
		} elsif ($news->{_cgi}->param('jump')) {
			$news->jump;
		} elsif (defined $news->{_cgi}->param('p')) {
			$news->view::home;
		} else {
			$news->die("Error: Unrecognized command");
		}
	} else {
		$news->view::home;		# home page
	}
	
	$news->display;				# display page

}


################################################################



package main;

#use MetalDoc;

# estimated total scripts used + 40 scripts
# ALL DONE IN THIS SINGLE SCRIPT !

my $news = MetalDoc->new;
$news->init;			# initialization
$news->run;




=head1 TEMPLATE EXPORTED VARIABLES
# VARIABLES THAT ALWAYS DEFINED IN EACH REQUEST
misc.is_logged				# 0: guest, 1: user, 2: editor, 3: admin	# user `rank` fetched from database
misc.site					# Test Company
misc.site_title				# http://test.org/
misc.page_title			# Welcome to Test Company website
misc.aid					# if logged in return aid / if not logged contain undefined value
misc.rank					# (misc.aid) rank / current user rank
misc.datetime				# current date & time
page					# default page is `main.html`
skindir					# skin/themes directory
author.{1,2,3}.{aid name rank email www}			# fetched from fetch_author()

$MetalDoc::Display = 0 -> redirect only / moved page / jump page

# CONFIG .. fetched from load_config()


# INTERNALS (don't use this functions for your main program. It's use by MetalDoc class ONLY)
view_comment()
date_time()
is_logged()
get_cookie()
load_config()
load_node()
get_modperl()

# COOKIE
misc.sid
misc.aid					# fetched from `is_logged()`, if logged in return username / if not logged, then contain undefined value


=cut






