
CREATE TABLE `cfg` (
	config_key		varchar(255),
	config_value		varchar(255)
);


INSERT INTO `cfg` (config_key, config_value) VALUES ('forum_disable', '0');
INSERT INTO `cfg` (config_key, config_value) VALUES ('site_name', 'My Website');
INSERT INTO `cfg` (config_key, config_value) VALUES ('site_desc', 'Just another Morum board');
INSERT INTO `cfg` (config_key, config_value) VALUES ('default_theme', 'fiapple');
INSERT INTO `cfg` (config_key, config_value) VALUES ('website', 'http://www.tetacorp.com/');
INSERT INTO `cfg` (config_key, config_value) VALUES ('abs_path', '');
INSERT INTO `cfg` (config_key, config_value) VALUES ('ext', '.msn');
INSERT INTO `cfg` (config_key, config_value) VALUES ('cookie_name', 'morum_');
INSERT INTO `cfg` (config_key, config_value) VALUES ('cookie_path', '');
INSERT INTO `cfg` (config_key, config_value) VALUES ('cookie_domain', '');
INSERT INTO `cfg` (config_key, config_value) VALUES ('cookie_secure', '0');
INSERT INTO `cfg` (config_key, config_value) VALUES ('session_length', '60');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_html', '0');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_html_tags', '0');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_bbcode', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_sig', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_chname', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_avatar', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('enable_confirm', '0');
INSERT INTO `cfg` (config_key, config_value) VALUES ('allow_autologin', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('posts_per_page', '15');
INSERT INTO `cfg` (config_key, config_value) VALUES ('topics_per_page', '40');
INSERT INTO `cfg` (config_key, config_value) VALUES ('poll_enable', '1');
INSERT INTO `cfg` (config_key, config_value) VALUES ('max_inbox_privmsg', '25');
INSERT INTO `cfg` (config_key, config_value) VALUES ('max_sentbox_privmsg', '25');
INSERT INTO `cfg` (config_key, config_value) VALUES ('enable_banner', '1');



CREATE TABLE `categories` (
cat_id		int,
cat_title		varchar(100),
cat_order	int
);

INSERT INTO `categories` (`cat_id`,`cat_title`,`cat_order`)
	VALUES ('1','Test Category 1','1');

CREATE TABLE `topics` (
topic_id			bigint unsigned,
forum_id			bigint unsigned,
topic_title		varchar(255),
topic_poster		bigint unsigned,
topic_time		bigint unsigned,		-- FORMAT:   unix epoch
topic_views		bigint unsigned,
topic_replies		bigint unsigned,
topic_status		tinyint,
topic_poll		tinyint,
topic_type		tinyint,
topic_first_post_id		bigint unsigned,
topic_last_post_id		bigint unsigned
);

INSERT INTO `topics` (`topic_id`,`forum_id`,`topic_title`,`topic_poster`,
`topic_time`,`topic_views`,`topic_replies`,`topic_status`,`topic_poll`,
`topic_type`,`topic_first_post_id`,`topic_last_post_id`)
	VALUES ('1','1','Welcome to Morum','2','1200731098','25',
	'1','0','0','0','1','2');

CREATE TABLE `users` (
user_id				bigint unsigned auto_increment not null,
user_active			tinyint,
username			varchar(25),
user_password		varchar(25),
user_session_time	bigint unsigned,	-- unix epoch
user_lastvisit			varchar(10),	-- FORMAT:   YYYY-MM-DD
user_regdate			varchar(10),
user_level			tinyint,			-- 1: admin, 2: moderator, 3: member
user_posts			bigint unsigned,
user_timezone		varchar(3),		-- +7, -12, etc
user_theme			varchar(16),
user_lang			varchar(2),
user_dateformat		varchar(10),
user_new_privmsg	tinyint,
user_login_tries		tinyint,
user_lastlogin_try		varchar(128),		-- unix epoch
user_showemail		tinyint,
user_email			varchar(255),
user_icq				varchar(30),
user_website			varchar(255),
user_location		varchar(100),
user_aim			varchar(255),
user_yim			varchar(255),
user_msnm			varchar(255),
user_interests		varchar(255),
user_occupation		varchar(100),
user_showavatar		tinyint,
user_avatar			varchar(255),
user_showsig		tinyint,
user_sig				varchar(255),
user_allowhtml		tinyint,
user_allowbbcode		tinyint,
user_allowsmile		tinyint,
user_allowavatar		tinyint,
user_allowpm		tinyint,
user_allowviewonline	tinyint,
user_rank			tinyint,
primary key (user_id)
);


INSERT INTO `users` (
	`user_id`,`user_active`,`username`,`user_password`,`user_session_time`,`user_lastvisit`,`user_regdate`,`user_level`,`user_posts`,`user_timezone`,`user_theme`,`user_lang`,`user_dateformat`,`user_new_privmsg`,`user_login_tries`,`user_lastlogin_try`,`user_showemail`,`user_email`,
	`user_icq`,`user_website`,`user_location`,`user_aim`,`user_yim`,`user_msnm`,`user_interests`,`user_occupation`,
	`user_showavatar`,`user_avatar`,`user_showsig`,`user_sig`,`user_allowhtml`,`user_allowbbcode`,`user_allowsmile`,`user_allowavatar`,`user_allowpm`,`user_allowviewonline`,`user_rank`
	) VALUES (
	'1','1','daniels','dgdgdg','unix_epoch','1200731098','1200731098','1','3151','7','fiapple','id','d M y','user_new_privmsg','1','2007','1','dns@cpan.org',
	'dns@cpan.org','www.tetacorp.com','Jakarta','dns@netscape.com','dns@yahoo.com','dns@hotmail.com','user_interests','user_occupation',
	'1','user_avatar','1','user_sig','1','1','1','1','1','1','1'
	);



CREATE TABLE `posts` (
post_id			bigint unsigned auto_increment not null,
topic_id			bigint unsigned,
forum_id			bigint unsigned,
poster_id		bigint unsigned,
post_time		bigint unsigned,		-- FORMAT: unix epoch
poster_ip		varchar(15),
post_username	varchar(15) default null,
enable_sig		tinyint,
post_edit_time	varchar(10),
post_edit_count	tinyint default '0',
post_text		text,
primary key (post_id)
);


INSERT INTO `posts` (
	post_id, topic_id, forum_id, poster_id, post_time, poster_ip, post_username, enable_sig, 
	post_edit_time, post_edit_count, post_text
	) VALUES (
	'1','1','1','1','972086460','127.0.0.1', null,
	'1','0','0','post_text'
	);


CREATE TABLE `ranks` (
rank_id			int unsigned auto_increment not null,
rank_title		varchar(32),
rank_special		tinyint,
rank_image		varchar(255) default null,
min_posts		bigint unsigned default '0',
primary key (rank_id)
);

INSERT INTO `ranks` (
	rank_id, rank_title, rank_special, rank_image, min_posts
	) VALUES (
	'1', 'System Administrator', '1', 'rank_image', '0'
	);


CREATE TABLE `sessions` (
session_id			varchar(64),
session_user_id		bigint unsigned,
session_start		bigint unsigned,
session_end			bigint unsigned,
session_ip			varchar(15)
);

CREATE TABLE `banners` (
banner_id		bigint unsigned auto_increment not null,
banner_name	varchar(16),
banner_code		text,
primary key (banner_id)
);


CREATE TABLE `forums` (
forum_id			bigint unsigned auto_increment not null,
cat_id			bigint unsigned,
forum_name		varchar(150),
forum_desc		text,
forum_status		tinyint,
forum_order		int,
forum_posts			bigint unsigned,
forum_topics			bigint unsigned,
forum_last_post_id	bigint unsigned,
prune_next			tinyint,
prune_enable	tinyint,
auth_read		tinyint,
auth_post		tinyint,
auth_reply		tinyint,
auth_edit		tinyint,
auth_delete		tinyint,
auth_sticky		tinyint,
auth_announce	tinyint,
auth_vote		tinyint,
auth_pollcreate	tinyint,
auth_attachments	tinyint,
primary key (forum_id)
);



INSERT INTO `forums` (
	forum_id, cat_id, forum_name, forum_desc, forum_status, forum_order, forum_posts, forum_topics, forum_last_post_id, prune_next, prune_enable, auth_read, auth_post, auth_reply, auth_edit, auth_delete, auth_sticky, auth_announce, auth_vote, auth_pollcreate, auth_attachments
	) VALUES (
	'1', '1', 'forum_name', 'forum_desc', '1', '1', '1', '1', '1', '0', '0', '0', '1', '1', '1', '1', '1', '1', '1', '1', '1'
	);















/*
INSERT INTO `sessions` (
	session_id, session_user_id, session_start, session_end, session_ip
	) VALUES (
	'session_id','session_user_id','session_start','session_end','session_ip'
	);
*/







-- posts
post_id topic_id forum_id poster_id post_time poster_ip post_username enable_sig post_edit_time post_edit_count post_text

-- users

-- topics
topic_id forum_id topic_title topic_poster topic_time topic_views topic_replies topic_status topic_poll topic_type topic_first_post_id topic_last_post_id

-- categories
cat_id cat_title cat_order

-- cfg
forum_disable
site_name
site_desc
default_theme
website
abs_path
ext
cookie_name
cookie_path
cookie_domain
cookie_secure
session_length
allow_html
allow_html_tags
allow_bbcode
allow_sig
allow_chname
allow_avatar
enable_confirm
allow_autologin
posts_per_page
topics_per_page
poll_enable
max_inbox_privmsg
max_sentbox_privmsg


