#!perl -w


=head1 index.pl

This code is a part of NewsCode, and is released under the Artistic License.
Copyright 2006-2007 by Daniel Sirait. See README and ARTISTIC for more
information, or see http://www.perl.com/perl/misc/Artistic.html
$Id: index.pl, v0.0.7 22/06/2007 22:07:42 daniels Exp $

=head2 Obfuscatometer using B::Fathom

index.pl syntax OK
 2332 tokens
  743 expressions
  222 statements
   18 subroutines
readability is 3.65 (readable)

=head3 Profiler (using dprofpp.bat)

Total Elapsed Time = 1.538190 Seconds
  User+System Time = 1.430190 Seconds

=cut

#use diagnostics;
#use CGI::Carp qw/fatalsToBrowser/;
use DBI;
use CGI;
#use Digest::SHA1 qw/sha1_hex/;
use Template;
use strict;
#use Cwd;
#use lib cwd . '/CPAN-lib';		# mod_perl (maybe PerlEx too) sometimes will need absolute path, please change this line to the correct path

our $VERSION = '0.0.1';

# Part 1 : DB config
my $dbh = DBI->connect("DBI:mysql:newscode:localhost:3306", 'root', '') || die $DBI::errstr;
my $template_dir = 'template/slashcode';
my $q = CGI->new;
my %params = $q->Vars;

# hmm, Safety first !
my (%content, @list, @menu, $page, %friends, %comm, $status, %latest_comm);

$page = 'content.html';	# Set default page
$status = 'Home';

# Part 2 : CGI parameters

if ($q->param) {
	if ($q->param('cmd') eq 'view') {
		if (defined $q->param('tid') ) {
			$page = 'content_permalink.html';
			$status = 'tid';
			($content{msg}[0], $content{title}[0], $content{date}[0], $content{category}[0], $content{tid}[0]) = ( &read_tid($q->param('tid')), $q->param('tid') );
			$comm{cid} = [ &read_comm($q->param('tid'), 'cid') ];
			$comm{tid} = [ &read_comm($q->param('tid'), 'tid') ];
			$comm{categ} = [ &read_comm($q->param('tid'), 'categ') ];
			$comm{ctime} = [ &read_comm($q->param('tid'), 'ctime') ];
			$comm{title} = [ &read_comm($q->param('tid'), 'title') ];
			$comm{poster} = [ &read_comm($q->param('tid'), 'poster') ];
			$comm{email} = [ &read_comm($q->param('tid'), 'email') ];
			$comm{www} = [ &read_comm($q->param('tid'), 'www') ];
			$comm{msg} = [ &read_comm($q->param('tid'), 'msg') ];
			$comm{ip_addr} = [ &read_comm($q->param('tid'), 'ip_addr') ];
			$comm{count} = &count_comm_tid($q->param('tid'));			# count comments for specific `tid`
		} elsif (defined $q->param('cat') ) {
			$page = 'content_cat.html';
			$status = 'cat';
			$content{title} = [ &read_categ('title') ];
			$content{msg} = [ &read_categ('msg') ];
			$content{date} = [ &read_categ('date') ];
			$content{tid} = [ &read_categ('tid') ];
			$content{category} = [ &read_categ('categ') ];
			$content{count_comm} = [ &count_comm_cat($params{cat}) ];	# total comment each topic
			$content{count} = &count_where('topic', $params{cat});
		} else {
			$page = 'error.html';
		}
	} elsif ($q->param('cmd') eq 'postcomment') {
		my $sth = $dbh->prepare("SELECT `ip_addr` FROM `comments` WHERE ip_addr = '$ENV{REMOTE_ADDR}';");
		$sth->execute;
		my $i = 0;
		while (my $data = $sth->fetchrow_hashref) {
			if ($ENV{REMOTE_ADDR} eq $data->{'ip_addr'}) {
				my @time_now = &time_now;
				my ($date, $month, $year, undef, undef) = split ' ', $data->{'ctime'};
				if ( ($date + 3) >= $time_now[0] ){						#and $month >= $time_now[1] and $year >= $time_now[2]){
					$i++;
				}
				die "Spammer shit !\n" if ++$i == 100;					# Spammer detection
			}
		}
		if (defined ($params{'name'} && $params{'email'} && $params{'www'} && $params{'comment'} && $params{'tid'} && $params{'categ'} ) ) {
			my @time_now = &time_now;
			$dbh->do("INSERT INTO comments (title, poster, ctime, email, www, msg, tid, categ, ip_addr) VALUES ('$params{title}', '$params{name}', '@time_now', '$params{email}', '$params{www}', '$params{comment}', '$params{tid}', '$params{categ}', '$ENV{REMOTE_ADDR}');");	# You don't see this :-)
			print $q->redirect("./?cmd=view;tid=$params{tid}");
		}
	} elsif ($q->param('cmd') eq 'xml') {
		$page = 'error.html';											# UNIMPLEMENTED YET :-(
	} else {
		$page = 'error.html';
	}
} else {
	&default_page;
}

{	# always fetch %friend, &read_menu
	&read_menu('category', 'categ', 'categ', 'ASC');	# fetch @menu
	$friends{'name'} = [ &read_db('friends', 'name', 'name', 'ASC') ];	# fetch %friends
	$friends{'email'} = [ &read_db('friends', 'email', 'name', 'ASC') ];
	$friends{'www'} = [ &read_db('friends', 'www', 'name', 'ASC') ];
	$friends{'count'} = &count_db('friends');
	&latest_comm;
}



# Part 3 : Subroutines

sub blogcode {
	${$_[0]} =~ s/  / &nbsp;/g;
	${$_[0]} =~ s/</&lt;/g;
	${$_[0]} =~ s/>/&gt;/g;
	${$_[0]} =~ s!\n!<br />\n!g;
	#${$_[0]} =~ s!http://(.*?) !<a href="http://$1">$1</a> !gi;							# clash with [img] tag

	${$_[0]} =~ s!\[b\]((.|\n)*)?\[/b\]!<b>$1</b>!gi;							# bold
	${$_[0]} =~ s!\[u\]((.|\n)*)?\[/u\]!<u>$1</u>!gi;							# underline
	${$_[0]} =~ s!\[i\]((.|\n)*)?\[/i\]!<i>$1</i>!gi;							# italic
	${$_[0]} =~ s!\[ul\]((.|\n)*)?\[/ul\]!<ul>$1</ul>!gi;						# ul
	${$_[0]} =~ s!\[li\]((.|\n)*)?\[/li\]!<li>$1</li>!gi;						# li
	${$_[0]} =~ s!\[url=(.*)?\]((.|\n)*)?\[/url\]!<a href="$1">$2</a>!gi;		# link
	${$_[0]} =~ s!\[img left\](.*?)(\[/img\])!<img src="$1" class="floatLeft" />!gi;	# img left
	${$_[0]} =~ s!\[img right\](.*?)\[/img\]!<img src="$1" class="floatRight" />!gi;	# img right
	${$_[0]} =~ s!\[img\](.*?)\[/img\]!<img src="$1" />!gi;						# <img src="images/firefox.jpg" alt="pic" class="floatLeft"/>
}

# default_page
sub default_page {
	$content{title} = [ &read_db('topic', 'title', 'tid','DESC') ];
	$content{msg} = [ &read_db('topic', 'msg', 'tid', 'DESC') ];
	$content{date} = [ &read_db('topic', 'tdate', 'tid', 'DESC') ];
	$content{tid} = [ &read_db('topic', 'tid', 'tid', 'DESC') ];
	$content{category} = [ &read_db('topic', 'categ', 'tid', 'DESC') ];
	$content{count_comm} = [ &count_comm ];			# total comment each topic
	$content{count} = &count_db('topic');
}

sub read_categ {
	my @read;
	# &read_categ('column name', 'column name', 'ASC or DESC');
	my $sth = $dbh->prepare("SELECT `$_[0]` FROM topic WHERE categ = '$params{cat}' ORDER BY tid DESC LIMIT 0,15;") || die $DBI::errstr;
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref){ push @read,  $data->{$_[0]} }
	$sth->finish;
	@read;
}

sub read_tid {
	my @read;
	my $sth = $dbh->prepare("SELECT * FROM `topic` WHERE tid = $_[0] LIMIT 0, 1;") || die $DBI::errstr;
	$sth->execute;

	while (my $data = $sth->fetchrow_hashref) {
		&blogcode(\$data->{'msg'});
		return $data->{'msg'}, $data->{'title'}, $data->{'tdate'}, $data->{'categ'};
		last;
		# BUG #1 immediate return, avoid using extra variables .. saving our memories
	}
}

sub read_db {
	# &read_db('table name', 'column name', 'order by', 'ASC or DESC');
	my @read;
	my $sth = $dbh->prepare("SELECT `$_[1]` FROM `$_[0]` ORDER BY $_[2] $_[3] LIMIT 0, 15;") || die $DBI::errstr;
	$sth->execute;
	my $test;
	while (my $data = $sth->fetchrow_hashref) {
		&blogcode(\$data->{$_[1]});											# not necessary
		push @read, $data->{$_[1]};
	}
	$sth->finish;
	($read[0] = 'No topic yet') if ($#read == -1);
	@read;
}

sub read_comm {
	my @read;
	my $sth = $dbh->prepare("SELECT `$_[1]` FROM `comments` WHERE tid = '$_[0]';") || die $DBI::errstr;
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		&blogcode(\$data->{$_[1]});
		push @read, $data->{$_[1]};
	}
	@read;
}

sub count_where {
	my $i = 0;
	my $sth = $dbh->prepare("SELECT * FROM `$_[0]` WHERE categ = '$_[1]';") || die $DBI::errstr;
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {$i++}
	return $i;
}


sub count_comm_tid {
	my $i = 0;
	my $sth = $dbh->prepare("SELECT * FROM `comments` WHERE `tid` = $_[0];");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {$i++}
	return $i;
}


sub count_comm_cat {
	my (@count_comm);
	my @list;
	my $i = 0;

	my $sth2 = $dbh->prepare("SELECT * FROM `topic` WHERE categ = '$_[0]' ORDER BY `tid` DESC LIMIT 0, 15;");
	$sth2->execute;
	while (my $data = $sth2->fetchrow_hashref) {
		push @list, $data->{tid};
	}
	$sth2->finish;

	foreach my $x(@list) {
		my $sth = $dbh->prepare("SELECT * FROM `comments` WHERE `tid` = $x;");
		$sth->execute;
		while (my $data = $sth->fetchrow_hashref) {
			$i++;
		}
		push @count_comm, $i;
		$i = 0;
	}
	return @count_comm;
}



sub count_comm {
	my (@count_comm);
	my @list;
	my $i = 0;

	my $sth2 = $dbh->prepare("SELECT * FROM `topic` ORDER BY `tid` DESC LIMIT 0, 15;");
	$sth2->execute;
	while (my $data = $sth2->fetchrow_hashref) {
		push @list, $data->{tid};
	}
	$sth2->finish;

	foreach my $x(@list) {
		my $sth = $dbh->prepare("SELECT * FROM `comments` WHERE `tid` = $x;");
		$sth->execute;
		while (my $data = $sth->fetchrow_hashref) {
			$i++;
		}
		push @count_comm, $i;
		$i = 0;
	}
	return @count_comm;
}

sub count_db {
	# &count_db('table name');
	my $sth = $dbh->prepare("SELECT * FROM `$_[0]` LIMIT 0, 15;") || die $DBI::errstr;
	$sth->execute;
	$DBI::rows - 1;
}

sub read_menu {
	my $sth = $dbh->prepare("SELECT $_[1] FROM `$_[0]` ORDER BY `$_[2]` $_[3];") || die $DBI::errstr;
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) { push @menu, $data->{$_[1]} }
	$sth->finish;
}

sub latest_comm {
	my @columns = qw/cid tid categ ctime title poster email www msg ip_addr/;
	$latest_comm{'count'} = 0;
	my $count_stat = 'need count';
	for my $i(@columns) {
		my @list;
		my $sth = $dbh->prepare("SELECT `$i` FROM `comments` ORDER BY `cid` DESC LIMIT 0, 15;") || die $DBI::errstr;
		$sth->execute;
		while (my $data = $sth->fetchrow_hashref) {
			&convert_time(\$data->{$i}) if $i eq 'ctime';
			push @list, $data->{$i};
			$latest_comm{'count'}++ if $count_stat eq 'need count';
		}
		$count_stat = 'count done';
		$latest_comm{$i} = [ @list ];
		$sth->finish;
		($sth, @list) = undef;
	}
}

sub random_arcticles {
	my $MAX_;
	my $rand_int = rand 15;
	my $sth = $dbh->prepare("SELECT * FROM `topic` WHERE `tid` = '$rand_int' ORDER BY `tid` DESC LIMIT 0, 15;") || die $DBI::errstr;
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		
	}
	$sth->finish;
}

=UNIMPLEMENTED
sub what_page {
	$webpage = 2;
	$page2 = 15 * $webpage;
	$page1 = $page2 - 15;
	my $sth = $dbh->prepare("SELECT * FROM `topic` ORDER BY `tid` DESC LIMIT $page1, $page2; ") || die $DBI::errstr;
	$sth->execute;
	$DBI::rows;
}
=cut



	# current time
sub time_now {
	my @dates = CORE::localtime;
	my @months = qw/January February March April Mei June July August September October November December/;
	my $sec = $dates[0];
	my $min = $dates[1];
	my $hour = $dates[2];
	my $date = $dates[3];
	my $month = $dates[4] + 1;
	my $year = $dates[5] + 1900;
	($sec = '0' . $sec) if length $sec == 1;
	($min = '0' . $min) if length $min == 1;
	($hour = '0' . $hour) if length $hour == 1;
	$date, $month, $year, $hour, $min;
}

sub convert_time() {
	my @months = qw/January February March April Mei June July August September October November December/;
	my @list = split ' ', ${$_[0]};
	$list[0] .= ' ';
	$list[1] = $months[$list[1]] . ' ';
	$list[3] = ', @' . $list[3];
	$list[4] = ':' . $list[4];
	${$_[0]} = join '', @list;
}



sub rand_hex_40 { sha1_hex(rand 99999999) }		# random hex number (40 digit)


# Part 4 : Templating system

	# TEMPLATE TOOLKIT CONFIG
my $config = {
    INCLUDE_PATH => [$template_dir],		# or list ref
    INTERPOLATE  => 0,						# expand "$var" in plain text
    EVAL_PERL    => 1,						# evaluate Perl code blocks
};

# create Template object
my $template = Template->new($config);

# define template variables for replacement
my $vars = {
	'template_dir'	=> $template_dir,
	'page'			=> $page,
	'menu'			=> \@menu,
	'content'		=> \%content,
	'friends'		=> \%friends,
	'comm'			=> \%comm,
	'latest_comm'	=> \%latest_comm,
	'status'		=> $status,
};

# specify input filename, or file handle, text reference, etc.
my $input = 'main.html';

# Part 5 : Response

CORE::print $q->header;		# prints header

# process input template, substituting variables
$template->process($input, $vars) || die $template->error;
	# END TEMPLATE


# Part 6 : Brain Washing

END {
	$dbh->disconnect;
	(@list, @menu, $page) = undef;
	undef %content;
	undef %friends;
	undef %comm;
	undef %latest_comm;
}


