-- 
-- Host: localhost
-- Generation Time: May 14, 2007 at 07:49 
-- Server version: 4.1.20
-- 
-- Database: `blogdoor`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `author`
-- 

CREATE TABLE `author` (
  `name` varchar(30) NOT NULL default '',
  `email` varchar(70) default NULL,
  `www` varchar(70) default NULL,
  `description` text,
  PRIMARY KEY  (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `author`
-- 

INSERT INTO `author` (`name`, `email`, `www`, `description`) VALUES ('Daniels', NULL, NULL, NULL);

-- --------------------------------------------------------

-- 
-- Table structure for table `category`
-- 

CREATE TABLE `category` (
  `categ` varchar(20) default NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `category`
-- 

INSERT INTO `category` (`categ`) VALUES ('Perl'),
('XS'),
('Football'),
('Personal'),
('Politics'),
('Uncategorized'),
('Music');

-- --------------------------------------------------------

-- 
-- Table structure for table `comments`
-- 

CREATE TABLE `comments` (
  `cid` bigint(20) unsigned NOT NULL auto_increment,
  `tid` bigint(20) unsigned default NULL,
  `categ` varchar(20) default NULL,
  `ctime` varchar(20) default NULL,
  `title` tinytext NOT NULL,
  `poster` varchar(25) default NULL,
  `email` varchar(70) default NULL,
  `www` varchar(70) default NULL,
  `msg` text NOT NULL,
  `ip_addr` varchar(15) default NULL,
  PRIMARY KEY  (`cid`),
  UNIQUE KEY `cid` (`cid`),
  KEY `cid_2` (`cid`),
  KEY `cid_3` (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

-- 
-- Dumping data for table `comments`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `friends`
-- 

CREATE TABLE `friends` (
  `name` varchar(30) NOT NULL default '',
  `email` varchar(70) default NULL,
  `www` varchar(70) default NULL,
  PRIMARY KEY  (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `friends`
-- 

INSERT INTO `friends` (`name`, `email`, `www`) VALUES ('Audrey Tang', 'cpan@audreyt.org', 'http://audret.org'),
('Larry Wall', 'larry@wall.org', 'http://www.wall.org/~larry'),
('Rasca', '', 'http://dnspropagation.com');

-- --------------------------------------------------------

-- 
-- Table structure for table `journal`
-- 

CREATE TABLE `journal` (
  `jid` bigint(20) unsigned NOT NULL auto_increment,
  `poster` varchar(25) default NULL,
  `jdate` varchar(20) default NULL,
  `title` tinytext NOT NULL,
  `msg` text NOT NULL,
  PRIMARY KEY  (`jid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `journal`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `spamers`
-- 

CREATE TABLE `spamers` (
  `ip` varchar(15) NOT NULL default '',
  `stime` varchar(20) NOT NULL default ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `spamers`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `topic`
-- 

CREATE TABLE `topic` (
  `tid` bigint(20) unsigned NOT NULL auto_increment,
  `categ` varchar(20) default NULL,
  `poster` varchar(25) default NULL,
  `tdate` varchar(20) default NULL,
  `title` tinytext,
  `msg` text,
  PRIMARY KEY  (`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;

-- 
-- Dumping data for table `topic`
-- 

INSERT INTO `topic` (`tid`, `categ`, `poster`, `tdate`, `title`, `msg`) VALUES (4, 'Personal', 'admin', '14 5 2007 12 03 11', 'Sayonara PHP', 'It’s been quite a while since I’ve decided to scrap PHP off my language preference list. It has been a downward spiral for me and PHP ever since I discovered Ruby and Ruby on Rails. CakePHP almost got me out of that spiral, but it wasn’t enough to pull me out of that blackhole of PHP disillusionment. I tried various ways to make PHP web development using the CakePHP framework as agile and as manageable as I can, even conceptualizing a better (from my perspective, at least) validation method for CakePHP. But in the end, I just felt it wasn’t worth it.\r\n\r\nI was trying to make CakePHP development as agile as Ruby on Rails development, knowing that Rails was the inspiration for CakePHP (the similarities are only too obvious), and yet the reason that it was Ruby on Rails and not PHP on Rails was precisely because PHP is not a very agile language in the first place.\r\n\r\nIt’s not that I hate PHP. It was, after all, where I began my career as a web developer. It’s just not one of those languages that I would feel proud to know (a bit maybe, compared to VB — I could never imagine myself programming in VB, heck if you can even call working with VB as ‘programming’).\r\n\r\nI’m sure I’m not the only one who feels this way about PHP. Some people would go to extremes to express how they really, oh so extremely, hate PHP (check out http://www.anti-php.net . I’m not one of those people. I will not say that PHP is generally a bad language, but just that it’s not a good language for me to use. The absence of namespaces, register globals (in later versions, they discovered this to be an insecure way of passing data and turned it off, but why create a feature so bad that it would have been obviously bad right from the start), magic quotes, and more. I’m sure a lot of people could point out those problems in PHP, but personally, I would not want to have to deal with those problems. Some people wouldn’t mind, and those are the PHP fanboys. I would mind, however, to have to explicitly deal with the misgivings of a language. That’s why I don’t feel that PHP is a good language for me to use.\r\n\r\nIt’s been almost seven years since I started programming in PHP. I can’t say I’ve significantly improved my programming skills with PHP in those seven years. And it’s not worth it to stick to it anymore. There are greener pastures around.');
