#!perl -w

# The way these things go, there are probably 6 or 8 kludgey ways to do
# it, and a better way that involves rethinking something that hasn't
# been rethunk yet.     -- Larry Wall

use Cwd;
use lib cwd;
use BS;
use CGI::Carp qw/fatalsToBrowser/;
use Digest::SHA1 qw/sha1_hex/;
use strict;

our $VERSION = '0.0.1';
our $CODENAME = 'imaginary';


# (Subject to change). the new() parameter may be deprecated. In near future, all configuration is compiled using PerlX or perlcc -B or PDK.
# But PerlX always be de facto primary implementation of BandSquad Engine	-- daniels
my $bs = BS->new(	-db			=> 'mysql',			# Oracle, Pg, Informix, Sybase, mysql. (Oracle is recommended)
					-dbname	=> 'bandsquad',
					-host		=> 'localhost',
					-port		=> 3306,
					-user		=> 'dns',
					-password	=> undef,
					-template_dir => 'template/RedCool/',	# easy for debugging, but may be deprecated in some future version.	-- daniels
				);

#my ($check_argv, $bandname) = BS::checkARGV;			# checkARGV is obsolete	-- daniels

#$bs->referer();		# disable for development & testing!

$bs->user_createEnvironment;

if (defined $ARGV[0]) {
	if ($bs->is_exist($ARGV[0])) {
		$bs->band_profile($ARGV[0]);
		$bs->random_bands;			# (Subject to change). `random_stuff` is an alias for random_bands & random_peoples & random label
		$bs->random_peoples;		# random_stuff(1)	0:random band/people, 1:metal/punk/grunge, 2:rock/pop/ska/funk/alternative, 3:jazz/blues, 4:disco/hip-hop/electronic/dance/rap, 5:folk/country/ethnic, 6:classic
	} else {
		$bs->error_page(404);
	}
} else {
	if (defined $bs->{_cgi}->param) {
		if (defined $bs->{_cgi}->param('u') ) {
			if ( $bs->is_exist($bs->{_cgi}->param('u')) ) {
				$bs->user_profile($bs->{_cgi}->param('u'));
				$bs->random_stuff;
			} else {
				$bs->error_page(404);
			}
		} elsif (defined $bs->{_cgi}->param('b')) {
			if ($bs->is_exist($bs->{_cgi}->param('b')) ) {
				$bs->band_profile( $bs->{_cgi}->param('b') );
				$bs->random_stuff;
			} else {
				$bs->error_page(404);
			}
		} elsif (defined $bs->{_cgi}->param('search')) {
			$bs->search( $bs->{_cgi}->param('search'), $bs->{_cgi}->param('search') );
			$bs->random_stuff;
		} elsif ($bs->{_cgi}->param('reg')) {

		} elsif ($bs->{_cgi}->param('')) {

		}
	} else {
		# (TO DO) Automatic generation of index.shtml by `bsed` daemon. This would not be recommended for idiotic PHP *programmers* :-D
		# BS Engine performance will increase with caching.		-- daniels

		# (TASK) Need to create Daemon if this feature is implemented.  --rasca

		# 'portald' is a program that sucks down headlines from assorted places on the internet, and puts them in the boxes for use on
		# Slash.  Exciting?  Nope. Bye2 Francisco Burzi, your PHP Nuke sucks  :-).  -- rob

		# "moderatord" - the moderation daemon. Calculates moderation information and assigns results to users  -- rob

		# `ratingd` - Automation of BS Engine RATING SYSTEM + AI moderator. (So we don't need the real damn stupid moderators)	-- daniels

		# `bitchslap` in Slashcode will be implemented in BS Engine (autokill(userID), autoban(IP_address) ). BTW, who need Administrators anyway?	-- daniels

		# `BS::Util::referer`tracker for $ENV{HTTP_REFERER}, may be disabled if the website grow bigger	-- daniels

		# Go through the files and require them all.  Each file will store its data and code in %task and execute any necessary
		# initialization.  We also do some rudimentary checks of whether an attacker with guest access on this system could be feeding
		# us bad code (the better solution, of course, is not to let attackers have local guest access).    # -- rob

	}
}


$bs->display;



=head1 NAME

	BandSquad Engine - is the code that runs BandSquad.

=head2 SYNOPSIS

	http://www.bandsquad.com/									# bandsquad home page
	http://dev.bandsquad.com/									# bandsquad developers  home page
	http://wap.bandsquad.com/									# bandsquad wap site (wml based)
	http://cpan.bandsquad.com/									# cpan mirror
	http://stuff.bandsquad.com/									# buy stuff and merchandising

	http://www.bandsquad.com/?bandname							# return band profile (bandname is case insensitive)
	http://www.bandsquad.com/?b=bandname						# return band profile (bandname is case insensitive)
	http://www.bandsquad.com/?u=123								# return user profile with specific userID
	http://www.bandsquad.com/?search=band;q=bandname			# return search result
	http://www.bandsquad.com/?search=user;q=username			# return search result
	http://www.bandsquad.com/?search=genreband;q=metalcore		# search specific music genre and return bands with similar genre
	http://www.bandsquad.com/?search=genreuser;q=metalcore		# search specific music genre and return users with similar genre
	http://www.bandsquad.com/?search=clocation_band;q=ca		# search band in specific country (Canada)
	http://www.bandsquad.com/?search=clocation_user;q=us		# search user in specific country (United States)
	http://www.bandsquad.com/?cmd=upload;q=file.mp3				# upload file

=head2 DESCRIPTION

	BandSquad Engine is the code that runs BandSquad. More than that, however, BandSquad Engine is an architecture
	for putting together web sites, podcast, and online radio. It comes with functionality for playing mp3 & video files,
	search engine, conducting polls, having discussions, and more; but it can be extended in innumerable ways.

	BandSquad Engine was originally written in C++ but later re-written in PerlX (cross platform compiler), and is built
	on top of Netscape FastTrack, X-CGI, and Oracle. It requires a database backend, though the only well-supported
	database used with it is Oracle (more databases will become well-supported as time goes on; PostgreSQL support
	is already well on its way). BandSquad Engine is fast, scalable, and secure (as evidenced by one of the best test
	cases you could have, running BandSquad itself).

=head2 FAQ

=head3 I have a really cool template for bandsquad theme, and I would like to see it added to the BandSquad.com. Will you distribute mine?

	Maybe. We don't have any rules concerning this at the moment, so it will be on a case by case
	basis. At some point in the future we will come up with a much better answer.

=head3 Can you make BandSquad Engine compliant with HTML x.x?

	Absolutely not. (That's not big deal :-).

=head3 Why don't you port BandSquad Engine to PHP/ASP/Python/Java/VB/Ruby/Fortran/Lisp?

	Because we like unreadable binary (it's 99% secure & very fast). And we hate the damn slow scripting
	languages (like PHP/Python/VBScript). And no, PerlX compiler is not slow. If you think it is, well, you
	are entitiled to your opinion, and we've heard it all before. However, you are free to use whatever programs
	and languages you like, and we even have a list of other systems and ports of BandSquad that you can
	choose from. Enjoy!

=head3 What's the differences between Perl script and PerlX?

	Perl script (Perl 1-6) is a scripting language. It can be compiled in byte-code form, but the
	byte-code can be decompiled by using `perl -MO=Deparse` switch.

	PerlX is an implementation of the Perl programming language. It's written in Spasm. PerlX doesn't always
	follow Perl 6 Synopses, Exegeses, and Apocalypses. PerlX take many of it's features from Perl 5, Perl 6,
	Spasm, Lisp, and Prolog. Logic programming tools is available at Logic::* namespace, low-level programming
	(Spasm embedding and auto-compiling features) is avalaible at Low::* namespace.

	And PerlX is not an interpreter. PerlX is a real damn fast compiler and can compile any PerlX script into
	native code, like C compiler does (not the byte-code generated one created by Malcolm Beattie).

	PerlX also have -encrypt=EncryptionMethod switch, so your executable binary will be protected from the
	reverse enginer and disassembler. Currently PerlX only have ByteFrost & FuckingLagged algorithm.
	But you can write your own encrytion method or write an implementation of MD5 algorithm (I'm too
	lazy (and too dumb) for this shit).

=head3 What is Spasm?

	Spasm is a state-of-the-art assembly language. Spasm was written directly in raw hexadecimal code to
	decrease execution time. Spasm language specification can be found at http://www.spasm.com/

=head3 How to compile BandSquad source?

	If you have trouble compiling the source in this packages, you're not alone. The cardinal rule: COMPILE
	ALL PROGRAMS IN EXACTLY THE SAME WAY THAT YOUR BANSQUAD BINARY WAS
	COMPILED. (Sorry for yelling.)

=head3 What is X-CGI?

	X-CGI is a plugin for the Netscape FastTrack/Enterprise, Apache, and IIS web server which increases the
	performance of compiled CGI programs written in PerlX, C, C++, or other compiled language. Much as
	mod_perl and FastCGI works with Apache, X-CGI works with web server to precompile scripts and add
	extended functionality such as embedding capabilities and persistent data connections. X-CGI is an
	universal accelerator for all compiled CGI programs. Unlike FastCGI/mod_perl/mod_python/mod_php/mod_ruby,
	X-CGI always treat CGI programs written in PerlX and C in same way. See http://www.x-cgi.com/
	for more information.

=head3 Can I run BandSquad under mod_perl or FastCGI?

	You can use Perl 5 implementation of BandSquad Engine to work under mod_perl and FastCGI.

=head3 Why do I have problems with mod_perl and Apache?

	Because you didn't install it according to the instructions, perhaps using older or beta versions of the software
	or prebuilt binaries or packages, or you don't have all the Perl modules installed properly, or because you are
	using PHP (as many people have reported problems using PHP and mod_perl both with Apache, and there's
	not much we, as lowly application programmers, can do about that :-).

=head3 How can I help?

	Sign up to bandsquad.com, give us feedback, help other users in our growing community, submit
	bug reports, and just generally participate.

=head3 What is discussed on dev.bandsquad.com?

	Anything that is on-topic. On-topic comments include anything directly related to BandSquad Engine feature.
	This excludes flames and discussions about BandSquad editorial policies. This also excludes discussions about
	other BandSquad-like projects. We reserve the right to delete any comments we feel are inappropriate.

=head3 How do I contact you guys about ... anything?

	We have several ways for you to get in touch with us.
		# Bug reports - Submit bug reports to http://dev.bandsquad.com/bugzilla/
		# Patches - Please submit patches to http://dev.bandsquad.com/patch/
		# Feature Requests - Please submit feature requests by directly sending an email to author.

=head2 CREDITS

	BandSquad Engine core developer
		Rasca Rat
		Daniel Sirait

	Website themes
		Andeas Viklund
		Ronald Frank
		Andre Frank

	WRC (Web Revision Control)
		Daniel Sirait

	Template Toolkit & XS Stash
		Andy Wardley <abw@wardley.org>
		Doug Steinwand <dsteinwand@citysearch.com>

	Quran.pm (Holy Quran book searchable database multi-lingual in both text and unicode formats)
		Ahmed Amin Elsheshtawy <mewsoft@cpan.org>

	HTML::BBCode
		Menno Blom <menno@b10m.net>

	Mason (High-performance, dynamic web site authoring system)
		Jonathan Swartz <swartz@pobox.com>
		Dave Rolsky <autarch@urth.org>
		Ken Williams <ken@mathforum.org>

	XML Parser
		Larry Wall <larry@wall.org>
		Clark Cooper <coopercc@netheaven.com>
		Matt Sergeant <matt@sergeant.org>

	Thanks to:
		Slashdot (http://slashdot.org/)
		Everything development company (http://www.everydevel.com/)
		Baba Flash (http://babaflash.com/)

	Fixes, Bug Reports, Optimizations, Support, and Ideas have been generously provided by:
		VJ Rianty.

=head2 Public WRC Server

	BandSquad Engine now has a private WRC server.
	You can access it by going to http://dev.bandsquad.com/wrc/

=head2 TODO LIST

	Automatic -switch for BandSquad themes. eg: if date eq 25 Dec then $bs->display('Christmas') ||
	1 Jan ('NewYear') || 13 Feb for Halloween (Black/Red Blood) || 1 Apr ('Mop') display ('Pink').	-- daniels

	(Subject to discuss ) TT2 will be replaced by Mason or HTML::Template by Sam Tregar? -- rasca

	Integration with Mason components (if TT2 replaced with Mason).  -- rasca

	(Subject to discuss) We need to create our own templating system? --rasca

	XML support. -- rasca

=head2 AUTHOR

	Daniel Sirait <dns@cpan.org> wrote version 0.x, 1.x

	Rasca Rat <rasca@bandsquad.com> picked up support, changed the API for version (2.x),
	provided documentation, and better web templates.

	Rasca Rat is now maintaining BandSquad Engine.

=head2 COPYRIGHT & LICENSE

	Copyright 2007 by Daniel Sirait.
	Copyright 2007 by Rasca Rat.

	This program is released under the ARTISTIC License.
	See README and LICENSE for more information, or see http://dev.bandsquad.com/artistic.html

=head2 LINKS

	http://www.bandsquad.com/
		The main site for BandSquad.

	http://www.bandsquad.com/?Regex
		The authors metalcore band. :-)

	http://cpan.org/
		Comprehensive Perl Archive Network.

	http://dev.bandsquad.com/
		Access to the bug reports, patches, suggestions, developers, and more.

=head2 VERSION

	$Id: index.px, v0.0.1 2007/07/05 20:48:02 daniels Exp $

	$Id: BS.pm, v0.0.8 2007/07/14 03:33:42 rasca Exp $

=cut
