package BS;

use Cwd;
use lib cwd;				# silly thing is, we don't even use this
#use BS::Constant;
use DBI;
use CGI qw/-private_tempfiles/;
use Template;
use strict;

our $VERSION = '0.0.1';

$CGITempFile::TMPDIRECTORY = 'tmp';

#	my %sql = (		# deprecated. use manual prepare() syntax -- rasca
#		select_band => "SELECT * FROM `bs_band`",
#		update_band => "UPDATE LOW_PRIORITY `bs_band` SET bandname = '' WHERE bandname = '' LIMIT 1",
#		select_user => "SELECT * FROM `bs_user`",
#		insert_user => "INSERT INTO `bs_user` () VALUES ('', '')",
#		update_user => "UPDATE LOW_PRIORITY `bs_user` SET username = '' WHERE username = '' LIMIT 1",
#		);

sub new {
	my $class = shift;
	my %new = @_;
	my $self = {'_dbh'	=> DBI->connect("DBI:$new{-db}:$new{-dbname}:$new{-host}:$new{-port}", $new{-user}, $new{-password}),
			'_cgi'	=> CGI->new,
			'_tt'	=> Template->new( {'INCLUDE_PATH' => [ $new{-template_dir} ], 'EVAL_PERL' => 0 } ),
			'user'	=> undef,
			'band'	=> undef,
			'misc'	=> undef,			# $self->{misc}->{page/status},
			'test'	=> sub {},			# closure (protected)
			};
	bless $self, $class;
}

AUTOLOAD { &error_page(404) }

DESTROY {
	my $self = shift;
	$self->{_dbh}->disconnect;		# subject to change. Change to Apache2::DBI to create persistent DB connection -- rasca
	undef %$self;
}

sub home_page {
	my $self = shift;
	my ($uid) = $_[0];
	my ($genre);
	my $sth = $self->{_dbh}->prepare("SELECT `ggenre` FROM `bs_users` WHERE `uid` = $uid");
	$sth->execute;
	while (my $fetch = $sth->fetchrow_hashref) {
		$genre = $fetch->{ggenre};
	}
}					# home_page (default(random mix)/metal/pop/rock/jazz/blues/) depending on user

sub error_page {
	my $self = shift;
	$self->{misc}->{status} = $_[0];
	#$self->{misc}->{status}->{code} = $BS::Constant::status_code{$_[0]};
	$self->{misc}->{page} = 'error.html';
	print $self->{_cgi}->header;
	die $_[0];		# error code
}		# not exist user/band, wrong pswd/wrong SID/cracking attempt



sub readDB {		# deprecated! use manual prepare statement -- rasca
	my $self = shift;
}


sub is_exist {
	# is_exist(`bs_users/bs_bands`, `bandname/email, $name)
	my $self = shift;
	my $sth = $self->{_dbh}->prepare("SELECT `$_[1]` FROM `$_[0]` WHERE `$_[1]` = '$_[2]' LIMIT 0, 1");
	$sth->execute;
	while (my $fetch = $sth->fetchrow_hashref) {
		if ($fetch->{$_[1]} eq $_[2]) {
			return 1;
			last;
		}
	}
	&error(404);
	return 0;
}			# check user/band is exist or not, case insensitive, return 1 or 0

sub dequote {}

sub unverifiedUser_create {	# $email
	my $self = shift;
	unless ( is_exist($_[0], 'bs_unver_users', 'email') && is_exist($_[0], 'bs_users', 'email', $self->{_cgi}->param('email') )  ) {
		$self->{_dbh}->do("INSERT INTO `bs_unver_users` (email, username, pswd, ver_code) VALUES ('$_[0]', '$_[1]', '$_[2]', '$_[3]')");
	} else {
		die "email already registered, please use different email address";
	}
}		# create unverified user


sub unverifiedUser_delete {}		# same as user_create ($email, )

sub user_create {	# $email / ($email, $username, $pswd)
	my $self = shift;
	my %data;
	my @table = qw/email username pswd/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `bs_unver_users` WHERE `email` = '$_[0]'");
	while (my $fetch = $$sth->fetchrow_hashref) {
		foreach my $i (@table) { $data{$i} = $fetch->{$i} }
		last;
	}
	$self->{_dbh}->do("DELETE LOW PRIORITY FROM `bs_unver_users` WHERE `email` = '$_[0]'");
	$self->{_dbh}->do("INSERT LOW PRIORITY INTO `bs_users` (email, username, pswd) VALUES ('$data{email}', '$data{username}', '$data{pswd}')");

}				# create new user, delete unverified user


sub user_addnews {}
sub user_msg {}					# add/remove msg max: 25, ('add/remove'), ('edit', 'msgnumber0-24')
sub user_testi {}				# add/remove testimonial/comment max: 25, ('add/remove'), ('edit', 'msgnumber0-24')

sub user_profile {
	my $self = shift;
	my @user_table = qw/uid username reg_date gender www email pswd ggenre ogenre instrument bands additional_bands about pics msg news files bookmark_users bookmark_bands/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `bs_users` WHERE `uid` = $_[0]");
	my %data;
	while (my $fetch = $sth->{fetchrow_hashref}) {
		$data{username} = $fetch->{username};
	}

	$self->{misc}->{page} = 'user_profile.html';

	$self->{user} = {
		username	=> $data{username},
		uid			=> $data{uid},
		reg_date	=> $data{reg_date},
		gender		=> $data{gender},
		www		=> $data{www},
		email		=> $data{email},
		ggenre		=> $data{ggrenre},
		ogenre		=> $data{ogenre},
		instrument	=> $data{instrument},
		bands		=> [ split ';', $data{bands} ],
		additonal_bands => [ split '#S#', $data{additional_bands} ],
		about		=> $data{about},
		pics			=> $data{pics},
		msg			=> { title => [], content => [], date => [] },		#, count => $#msg_title},	is deprecated. use user.msg.title.size -- rasca
		news		=> { title => [], content => [], date => [] },
		mp3_pub	=> [ split '#S#', $data{mp3_pub} ],
		mp3_priv	=> [ split '#S#', $data{mp3_priv} ],
		vid_pub		=> [ split '#S#', $data{vid_pub} ],
		vid_priv		=> [ split '#S#', $data{vid_priv} ],
		bookmark_users => { uid			=> [ split ';', $data{bookmark_users} ],		# need fix
							username	=> [ &get_username(split ';', $data{bookmark_users}) ],		# need fix
							},
		bookmark_bands => [ split ';', $data{bookmark_bands} ],
		};

	undef %data;		# I want to be empty string so they will not get duplicated along with %user, $self->{user}, user		-- daniels
	# Case: if each request need 400kb memory, just imagine if index page is being requested more than 100 request / sec. This means 400kb x 100 = 40000 kb / or 40 mb
	# use less 'memory' currently not found in many CMS/Web Forum/Blog software. That's why they're so slow
	# you can't always depend on GC right ?
	# I found this nice feature in Slashcode & Everything development company 	--  daniels
}

sub user_update {	# $uid, $username,
	my $self = shift;
	my %param = $self->{_cgi}->Vars;
	# &quote(\%param);
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `username` = '$param{username}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `gender` = '$param{gender}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `www` = '$param{www}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `pswd` = '$param{pswd}' WHERE `uid` = $_[0]");		# encrypt $pswd
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `ggenre` = '$param{ggenre}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `ogenre` = '$param{ogenre}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `instrument` = '$param{instrument}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `bands` = '$param{bands}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `additional_bands` = '$param{additional_bands}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `about` = '$param{about}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `pics` = '$param{pics}' WHERE `uid` = $_[0]");
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `msg` = '$param{msg}' WHERE `uid` = $_[0]");
	#$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `news` = '$param{news}' WHERE `uid` = $_[0]");
}

sub user_update_pswd {		# $uid, $email
	my $self = shift;
	my %param = $self->{_cgi}->Vars;
	my $sth = $self->{_dbh}->prepare("SELECT `pswd` FROM `bs_users` WHERE `pswd` = '$param{oldpswd}'");
	$sth->execute;
	while (my $fetch = $sth->execute) {

	}

	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `pswd` = '$param{pswd}' WHERE `uid` = '$param{uid}'");
}


sub user_delete {}	# is this needed? We do not allow a single moderator a 'reign of terror'	 -- daniels


sub user_active {	# ($uid, 0/1)
	my $self =shift;
	$self->{_dbh}->do("UPDATE LOW_PRIORITY `bs_users` SET `is_active` = $_[1] WHERE `uid` = $_[0]");
}

sub user_file {}

sub get_username {
	my $self = shift;
	my @usernames;
	for (@_) {
		my $sth = $self->{_dbh}->prepare("SELECT `username` FROM `bs_users` WHERE uid = $_ LIMIT 0, 1");
		$sth->execute;
		while (my $fetch= $sth->fetchrow_hashref) {
			push @usernames, $fetch->{username};
		}
	}
	return @usernames;
}

sub random_peoples {		# (uid)
	# metal/punk/grunge, rock/pop/ska/funk/alternative, jazz/blues, disco/hip-hop/electronic/dance/rap, folk/country/ethnic, classic ... if not exist then pick -> random
	my $self = shift;
	my $ggenre = $self->{user}->{ggenre};
	my (@uid, @name, @pics);
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `bs_users` WHERE `ggenre` LIKE '%$ggenre%' LIMIT 0 , 10");	# TODO: DESC / descending
	$sth->execute;
	while (my $fetch = $sth->fetchrow_hashref) {
		push @uid, $fetch->{uid};
		push @name, $fetch->{username};
		my (@split_pics) = split(';', $fetch->{pics});
		push @pics, $split_pics[0];
	}
	$self->{misc}->{peoples}->{name} = [@name];
	$self->{misc}->{peoples}->{uid} = [@uid];
	$self->{misc}->{peoples}->{pics} = [@pics];
	#return @uid, @name;
}


sub getpics {

}

# randomize people & bands

sub random_bands {		# ($uid)
	my $self = shift;
	my $ggenre = $self->{user}->{ggenre};
	my $sth = $self->{_dbh}->prepare("SELECT `bandname` FROM `bs_bands` WHERE `ggenre` = '$ggenre' LIMT 0, 10");
	$sth->execute;
	while (my $fetch = $sth->fetchrow_hashref) {

	}
}		#  return $self->{misc}->{bands}->[@bandname/@pics]

sub random_stuff {		# ($uid)
	&random_peoples($_[0]);
	&random_bands($_[0]);
}

sub createEnv {		# ($uid)
	my $self = shift;
	my @user_table = qw/uid username sid reg_date gender ggenre ogenre instrument bands additional_bands pics/;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `bs_users` WHERE `uid` = $_[0]");
	my %data;
	while (my $fetch = $sth->{fetchrow_hashref}) {
		for (@user_table) {
			$data{$_} = $fetch->{$_};
		}
	}

	$self->{misc}->{page} = 'user_profile.html';
	my @pics = split ';', $data{pics};

	$self->{user} = {
		username	=> $data{username},
		uid			=> $data{uid},
		sid			=> $data{sid},
		reg_date	=> $data{reg_date},
		gender		=> $data{gender},
		ggenre		=> $data{ggrenre},
		ogenre		=> $data{ogenre},
		instrument	=> $data{instrument},
		bands		=> { bandname => [split ';', $data{bands} ],
						 bandpics => [get_pics('band', split ';', $data{bands})],
					   },
		additonal_bands => { bandname => [ split ';', $data{additional_bands} ],
							 bandpics => [get_pics('band', split ';',$data{additional_bands}) ],
							},
		pics		=> $pics[0],
		mp3_pub		=> [ split '#S#', $data{mp3_pub} ],
		mp3_priv	=> [ split '#S#', $data{mp3_priv} ],
		vid_pub		=> [ split '#S#', $data{vid_pub} ],
		vid_priv	=> [ split '#S#', $data{vid_priv} ],
		};

	undef %data;
}	# cookies, user.ggenre,



# band specific view
sub band_new_testimonial {}			# max: 25
sub band_update_testimonial {}		# max: 25
sub band_profile {
	my $self = shift;
	my %data;
	my $sth = $self->{_dbh}->prepare("SELECT * FROM `bs_bands` WHERE bandname = '$_[0]'");
	$sth->execute;
	my @band_table = qw/bandname is_active members former additional genre label location c_location about linked_bands band_pics reputation rating activity/;
	for my $i (@band_table) {
		while (my $fetch = $sth->fetchrow_hashref) {
			$data{$i} = $fetch->{$i};
		}
	}

	my @linked_band = split ';', $data{linked_bands};		# subject to change. THIS IS A BAD IDEA -- rasca
	my @members = split ';', $data{members};
	my @former = split ';', $data{members};
	my @additional = split ';', $data{members};
	$self->{misc}->{page} = 'band_profile.html';
	$self->{band} = {

	};
	undef %data;
}

sub band_create {}
sub band_news {}
sub band_update {}			# add member, additional
sub band_delete {}			# only if last user (founder) delete this band, delete_band($bandname)

sub label_create {}			# subject to discuss. RECORDING COMPANY REGISTRATION -- rasca
sub label_profile {}
sub label_update {}
sub label_delete {}




sub display {
	my $self = shift;
	my $vars = {
		'template_dir'	=> $self->{template_dir},
		'status'	=> $self->{misc}->{status},		# error page
		'band'		=> $self->{band},				# hash ref
		'user'		=> $self->{user},				# hash ref
		'misc'		=> $self->{misc},				# misc.page, misc.status,
	};

	# specify input filename, or file handle, text reference, etc.
	my $input = 'main.html';

	# process input template, substituting variables
	print $self->{_cgi}->header;
	$self->{_tt}->process($input, $vars) || die $self->{_tt}->error;
		# END TEMPLATE
}



sub optimize_table {
	my $self = shift;
	$self->{_dbh}->do("OPTIMIZE TABLE `bs_unver_users`, `bs_users`, `bs_bands`, `bs_labels`, `bs_bandfiles`, `bs_userfiles`");
}
sub repair_table {
	my $self = shift;
	$self->{_dbh}->do("REPAIR TABLE `bs_unver_users`, `bs_users`, `bs_bands`, `bs_labels`, `bs_bandfiles`, `bs_userfiles`");
}
sub check_table {
	my $self = shift;
	$self->{_dbh}->do("CHECK TABLE `bs_unver_users`, `bs_users`, `bs_bands`, `bs_labels`, `bs_bandfiles`, `bs_userfiles`")
}
sub analyze_table {
	my $self = shift;
	$self->{_dbh}->do("ANALYZE TABLE `bs_unver_users`, `bs_users`, `bs_bands`, `bs_labels`, `bs_bandfiles`, `bs_userfiles`");
}
sub empty_unverifiedUser {
	my $self = shift;
	$self->{_dbh}->do("TRUNCATE `bs_unver_users`");
}
sub checkARGV {					# S2D	-- daniels
	if (defined $ARGV[0] ) {
		#die "Invalid bands!\n" if $ARGV[0] =~ m/=|\+|#/;	# BUGS #1: Can't use #, =, + char
		# PATCH ! # => %23, = => %3D, + = %2B
		#$ARGV[0] =~ s/%(..)/pack("c", hex($1))/ge;		# Just make sure, it will works :-)
		$ARGV[0] =~ s/%23/#/g;
		$ARGV[0] =~ s/%3D/=/g;
		$ARGV[0] =~ s/%2B/\+/g;
		$ARGV[0] =~ s`\\\\`%doublebackslash%`g;
		$ARGV[0] =~ s`\\(\W)`$1`g;
		$ARGV[0] =~ s`%doublebackslash%`\\`g;
		return 1, $ARGV[0];
	} else { return 0, undef }
}


sub uploadFile {}		# ($param{'filename'})
sub cookie {}

sub massEmail {
	my $self = shift;
	my ($from, $subject, $content) = @_;
	my @to;
	my $sth = $self->{_dbh}->prepare("SELECT `email` FROM `bs_users`");
	$sth->execute;
	while (my $fetch = $sth->fetchrow_hashref) {
		push @to, $fetch->{email};
	}
	for (@to) {
		die "Can't send email to $_\n" unless &sendMail($_, $from, $subject, $content);
	}
}


sub sendMail {
	my ($to, $from, $subject, $content) = @_;
	open MAIL, "|/lib/sbin/sendmail -t" or return 0;
	print <<MAIL;
To: $to
From: $_
Subject: $subject

$content

MAIL
	close MAIL or return 0;
	return 1;
}

sub referer {		# obsolete! text file 2 DB
	my $self = shift;
	my $referer = $ENV{HTTP_REFERER};
	$referer =~ s!^http://(.*?)/.*!$1!i;
	$referer =~ s!^www\.!!i;

	my $sth = $self->{_dbh}->prepare("SELECT `referer_url` FROM `bs_referer`");
	$sth->execute;
}

sub deleteReferer {}

1;


=head1 NAME

	BS.pm - Primary http init & response handler for BandSquad Engines.

=head2 SYNOPSIS

	-

=head2 DESCRIPTION

	-

=head2 AUTHOR

	Daniel Sirait <dns@cpan.org>

=head2 COPYRIGHT & LICENSE

	Copyright 2007 by Daniel Sirait.

	This program is released under the ARTISTIC License.
	See README and LICENSE for more information, or see http://dev.bandsquad.com/artistic.html

=head2 LINKS

	http://cpan.uwinnipeg.ca/
		CPAN. University of Winnipeg, Canada.

=head2 NOTES

=cut

