	
package BS::Constant;

# . * - _
our %unescapeHTML = (
	'#' => '%23',
	'=' => '%3D',
	'+' => '%2B',
	'`' => '%60',
	'~' => '%7E',
	'!' => '%21',
	'@' => '%40',
	'$' => '%24',
	'%' => '%25',
	'^' => '%5E',
	'&' => '%26',
	'(' => '%28',
	')' => '%29',
	'[' => '%5B',
	']' => '%5D',
	'{' => '%7B',
	'}' => '%7D',
	':' => '%3A',
	';' => '%3B',
	"'" => '%27',
	'"' => '%22',
	',' => '%2C',
	'<' => '%3C',
	'>' => '%3E',
	'/' => '%2F',
	'\\' => '%5C',
	'?' => '%3F',
	'|' => '%7C',
);


our %rfc2068_status = (
	100=>'Continue',
	101=>'Switching Protocols',
	200=>'OK',
	201=>'Created',
	202=>'Accepted',
	203=>'Non-Authoritative Information',
	204=>'No Content',
	205=>'Reset Content',
	206=>'Partial Content',
	300=>'Multiple Choices',
	301=>'Moved Permanently',
	302=>'Moved Temporarily',
	303=>'See Other',
	304=>'Not Modified',
	305=>'Use Proxy',
	400=>'Bad Request',
	401=>'Unauthorized',
	402=>'Payment Required',
	403=>'Forbidden',
	404=>'Not Found',
	405=>'Method Not Allowed',
	406=>'Not Acceptable',
	407=>'Proxy Authentication Required',
	408=>'Request Time-out',
	409=>'Conflict',
	410=>'Gone',
	411=>'Length Required',
	412=>'Precondition Failed',
	413=>'Request Entity Too Large',
	414=>'Request-URI Too Large',
	415=>'Unsupported Media Type',
	500=>'Internal Server Error',
	501=>'Not Implemented',
	502=>'Bad Gateway',
	503=>'Service Unavailable',
	504=>'Gateway Time-out',
	505=>'HTTP Version not supported'
);

our %apache_status = (
	HTTP_CONTINUE => 100,
	HTTP_SWITCHING_PROTOCOLS => 101,
	HTTP_OK => 200,
	HTTP_CREATED => 201,
	HTTP_ACCEPTED => 202,
	HTTP_NON_AUTHORITATIVE => 203,
	HTTP_NO_CONTENT => 204,
	HTTP_RESET_CONTENT => 205,
	HTTP_PARTIAL_CONTENT => 206,
	HTTP_MULTIPLE_CHOICES => 300,
	HTTP_MOVED_PERMANENTLY => 301,
	HTTP_MOVED_TEMPORARILY => 302,
	HTTP_SEE_OTHER => 303,
	HTTP_NOT_MODIFIED => 304,
	HTTP_USE_PROXY => 305,
	HTTP_BAD_REQUEST => 400,
	HTTP_UNAUTHORIZED => 401,
	HTTP_PAYMENT_REQUIRED => 402,
	HTTP_FORBIDDEN => 403,
	HTTP_NOT_FOUND => 404,
	HTTP_METHOD_NOT_ALLOWED => 405,
	HTTP_NOT_ACCEPTABLE => 406,
	HTTP_PROXY_AUTHENTICATION_REQUIRED => 407,
	HTTP_REQUEST_TIME_OUT => 408,
	HTTP_CONFLICT => 409,
	HTTP_GONE => 410,
	HTTP_LENGTH_REQUIRED => 411,
	HTTP_PRECONDITION_FAILED => 412,
	HTTP_REQUEST_ENTITY_TOO_LARGE => 413,
	HTTP_REQUEST_URI_TOO_LARGE => 414,
	HTTP_UNSUPPORTED_MEDIA_TYPE => 415,
	HTTP_INTERNAL_SERVER_ERROR => 500,
	HTTP_NOT_IMPLEMENTED => 501,
	HTTP_BAD_GATEWAY => 502,
	HTTP_SERVICE_UNAVAILABLE => 503,
	HTTP_GATEWAY_TIME_OUT => 504,
	HTTP_VERSION_NOT_SUPPORTED => 505,
	HTTP_VARIANT_ALSO_VARIES => 506,
);

1;

