//****************************************************************************
//Copyright (C) 2004 Macromedia, Inc. All Rights Reserved.
//The following is Sample Code and is subject to all restrictions on
//such code as contained in the End User License Agreement accompanying
//this product.
//****************************************************************************

/* 
Data types and general coding example
This example shows you how to use data types and general coding principles.
Also shows you how to use several components in an application.
*/

// import component classes.
import mx.controls.*;
import mx.containers.*;
import mx.controls.gridclasses.DataGridColumn;

// add components to main timeline
this.createClassObject(Label, "nowplaying_lbl", 1, {_x:35, _y:0});
nowplaying_lbl.setSize(530, 20);
nowplaying_lbl.setStyle("color", 0xFFFFFF);
this.createClassObject(MediaController, "nowplaying_mediacon", 2, {_x:35, _y:16});
nowplaying_mediacon.setSize(530, 24);
this.createClassObject(Accordion, "jukebox_acc", 3, {_x:25, _y:40});
jukebox_acc.setSize(550, 360);

// configure components on main timeline
nowplaying_lbl.autoSize = "center";
nowplaying_lbl.html = true;
nowplaying_lbl.text = "";
nowplaying_mediacon.backgroundStyle = "none";
nowplaying_mediacon.controllerPolicy = "off";

// add the children to the Accordion component
var library = jukebox_acc.createChild(mx.core.View, "library_mc", {label:" 1. Library"});
var playlist = jukebox_acc.createChild(mx.core.View, "playlist_mc", {label:" 2. Playlist"});
var nowplaying = jukebox_acc.createChild(mx.core.View, "nowplaying_mc", {label:" 3. Now Playing"});

// add component instances to the Accordion component's children.
library.createClassObject(Tree, "library_tree", 100, {_x:10, _y:10});
library.library_tree.setSize(530, 280);

playlist.createClassObject(DataGrid, "playlist_dg", 200, {_x:10, _y:10});
playlist.playlist_dg.setSize(530, 260);
playlist.createClassObject(Label, "playlist_lbl", 201, {_x:10, _y:270});
playlist.playlist_lbl.setSize(530, 20);

var title_dgc:DataGridColumn = new DataGridColumn("title");
title_dgc.headerText = "Title:";
title_dgc.width = 300;
playlist.playlist_dg.addColumn(title_dgc);

var artist_dgc:DataGridColumn = new DataGridColumn("artist");
artist_dgc.headerText = "Artist:";
artist_dgc.width = 150;
playlist.playlist_dg.addColumn(artist_dgc);

var length_dgc:DataGridColumn = new DataGridColumn("length");
length_dgc.headerText = "Length:";
length_dgc.width = 60;
playlist.playlist_dg.addColumn(length_dgc);

playlist.playlist_lbl.autoSize = "center";
playlist.playlist_lbl.text = "{PLAYLIST STATS}";

nowplaying.createClassObject(Loader, "cover_ldr", 300, {_x:10, _y:10});
nowplaying.cover_ldr.setSize(200, 200);
nowplaying.createClassObject(MediaController, "mp3_mediacon", 301, {_x:220, _y:10});
nowplaying.mp3_mediacon.setSize(300, 70);
nowplaying.createClassObject(TextArea, "id3_ta", 302, {_x:220, _y:90});
nowplaying.id3_ta.setSize(300, 160);
nowplaying.createClassObject(MediaDisplay, "mp3_mediadisp", 303, {_x:220, _y:260});
nowplaying.mp3_mediadisp.setSize(70, 70);

nowplaying.mp3_mediacon.associateDisplay(nowplaying.mp3_mediadisp);
nowplaying_mediacon.associateDisplay(nowplaying.mp3_mediadisp);

nowplaying.mp3_mediacon.controllerPolicy = "on";
nowplaying.id3_ta.editable = false;
nowplaying.id3_ta.html = true;
var borders_array:Array = new Array("borderColor", "buttonColor", "shadowColor", "highlightColor", "shadowCapColor", "borderCapColor");
for (var side in borders_array) {
	nowplaying.id3_ta.setStyle(borders_array[side], 0xFFFFFF);
}



updatePlaylistStats();

var dgListener:Object = new Object();
dgListener.change = function(evt:Object) {
	playSong();
};
playlist.playlist_dg.addEventListener("change", dgListener);


var songs_xml:XML = new XML();
songs_xml.ignoreWhite = true;

songs_xml.onLoad = function(success:Boolean) {
	if (success) {
		library.library_tree.dataProvider = this.firstChild;
	} else {
		trace("unable to load/parse library.xml");
	}
};

songs_xml.load("http://localhost/bandsquad/jukebox/playlist.cgi");

var treeListener:Object = new Object();
treeListener.change = function(evt:Object) {
	var selectedMP3:XMLNode = evt.target.selectedNode;
	if (evt.target.getIsBranch(selectedMP3)) {
		evt.target.setIsOpen(selectedMP3, !evt.target.getIsOpen(selectedMP3), true);
	} else {
		playlist.playlist_dg.addItem({title:selectedMP3.attributes['label'], artist:selectedMP3.attributes['artist'], length:selectedMP3.attributes['length'], track:selectedMP3.attributes['track'], album:selectedMP3.attributes['album'], cover:selectedMP3.attributes['cover'], src:selectedMP3.attributes['src']});
		updatePlaylistStats();
	}
};
library.library_tree.addEventListener("change", treeListener);

function playSong() {
	var thisSong:Object = playlist.playlist_dg.selectedItem;
	stopAllSounds();
	nowplaying.mp3_mediadisp.setMedia(thisSong.src, "MP3");
	nowplaying.mp3_mediadisp._playerImpl._sound.onID3 = function() {
		nowplaying_lbl.text = "<b>"+this.id3.artist+"</b> -- "+this.id3.songname+" ("+thisSong.length+")";
		var id3_str:String = new String();
		id3_str = "<textformat tabstops='[70]'>";
		id3_str += "<b>Artist:</b>\t"+this.id3.artist+newline;
		id3_str += "<b>Album:</b>\t"+this.id3.album+newline;
		id3_str += "<b>Song:</b>\t"+this.id3.songname+newline;
		id3_str += "<b>Track:</b>\t"+this.id3.track+newline;
		id3_str += "<b>Year:</b>\t"+this.id3.year+newline;
		//id3_str += "<b>Genre:</b>\t"+this.id3.genre+newline;
		id3_str += "</textformat>";
		//id3_str += "<p><font size='9'>"+this.id3.TSSE+"</font></p>";
		nowplaying.id3_ta.text = id3_str;
	};
	nowplaying.mp3_mediadisp.play(0);
	nowplaying.cover_ldr.load(thisSong.cover);
}

function updatePlaylistStats():Void {
	var totalSeconds_number:Number = 0;
	var numSongs_number:Number = playlist.playlist_dg.dataProvider.length;
	for (var i = 0; i<numSongs_number; i++) {
		var time_array:Array = playlist.playlist_dg.dataProvider.getItemAt(i).length.split(":");
		totalSeconds_number += (Number(time_array[0]*60)+Number(time_array[1]));
	}
	var numMinutes = Math.floor(totalSeconds_number/60);
	var numSeconds = totalSeconds_number%60;
	var playlistLabel_string:String = numSongs_number+" "+((numSongs_number == 1) ? "song" : "songs");
	playlistLabel_string += ", "+numMinutes+":"+((numSeconds<10) ? "0" : "")+numSeconds;
	if (numMinutes<60) {
		// playlist length is under an hour.
	} else if (numMinutes<1440) {
		playlistLabel_string += " ("+(Math.round(numMinutes/60*10)/10)+" hours)";
	} else {
		playlistLabel_string += " ("+(numMinutes/1440)+" days)";
	}
	playlist.playlist_lbl.text = playlistLabel_string;
}