#!perl -w

=head1 index.pl

This code is a part of BlogDoor, and is released under the Artistic License.
Copyright 2006-2007 by Daniel Sirait. See README and ARTISTIC for more
information, or see http://www.perl.com/perl/misc/Artistic.html
$Id: index.pl,v 0.0.1 15/03/2007 22:07:42 daniels Exp $

This work dedicated to Neisya

=head2 Obfuscatometer using B::Fathom

index.pl syntax OK
  645 tokens
  182 expressions
   67 statements
    8 subroutines
readability is 3.38 (readable)

=cut


use DBI;

BEGIN { our $dbh = DBI->connect("DBI:SQLite:blogdoor.db.pod", '', '') || die $DBI::errstr }

# mod_perl (maybe PerlEx too) sometimes will need absolute path, please change this line to the correct path
use lib './';

use CGI::Carp qw/fatalsToBrowser/;
use CGI;
use Digest::SHA1 qw/sha1_hex/;
use Template;
#use strict;

my $q = CGI->new;

# hmm, Safety first !
my (@content_date, @content_title, @content, @list, @menu, @category, @content_tid, $page);

$page = 'content.html';	# Set default page

if ($q->param) {
	if ($q->param('cmd') eq 'view') {
		if (defined $q->param('tid')) {
			($content[0], $content_title[0], $content_date[0], $category[0], $content_tid[0]) = ( &read_tid($q->param('tid')), $q->param('tid') );
			$page = 'content_permalink.html';
		} elsif (defined $q->param('cat')) {
			@content_title = &read_categ($q->param('cat'), 'title');
			@content = &read_categ($q->param('cat'), 'msg');
			@content_date = &read_categ($q->param('cat'), 'tdate');
			@content_tid = &read_categ($q->param('cat'), 'tid');
			@category = &read_categ($q->param('cat'), 'categ');
		} else {
			$page = 'error.html';
		}
	} elsif ($q->param('cmd') eq 'postcomment') {
		if (defined $q->param('name') and defined $q->param('email') and defined $q->param('www') and defined $q->param('tid') ) {
			$dbh->do("INSERT INTO comments (cid, tid, categ, ctime, poster, email, www, msg) VALUES ();");
		}
	} elsif ($q->param('cmd') eq 'xml') {
		$page = 'error.html';
	} else {
		$page = 'error.html';
	}
} else {
	&default_page;
}

@menu = &read_menu('category', 'categ', 'categ', 'ASC');

sub text2html {
	${$_[0]} =~ s/\n/<br \/>\n/g;
	${$_[0]} =~ s/  / &nbsp;/g;
}

sub read_categ {
	my @read;
	my $sth = $dbh->prepare("SELECT $_[1] FROM topic WHERE categ = '$_[0]' ORDER BY tid DESC LIMIT 0, 15;") || die $DBI::errstr;
	$sth->execute;
	
	while (my $data = $sth->fetchrow_hashref) {
		&text2html(\$data->{$_[1]});
		push @read, $data->{$_[1]};
	}
	
	$sth->finish;
	@read;
}

sub read_tid {
	my @read;
	my $sth = $dbh->prepare("SELECT * FROM topic WHERE tid = $_[0] LIMIT 0, 1;") || die $DBI::errstr;
	$sth->execute;
	
	while (my $data = $sth->fetchrow_hashref) {
		&text2html(\$data->{'msg'});
		return $data->{'msg'}, $data->{'title'}, $data->{'tdate'}, $data->{'categ'};
		# BUG #1 immediate return, avoid using extra variables .. save our memories
	}
}

sub read_db {
	# &read_rb('table name', 'column name', 'order by', 'ASC or DESC');
	my @read;
	my $sth = $dbh->prepare("SELECT $_[1] FROM $_[0] ORDER BY $_[2] $_[3] LIMIT 0, 15;") || die $DBI::errstr;
	$sth->execute;
	
	while (my $data = $sth->fetchrow_hashref) {
		&text2html(\$data->{$_[1]});
		push @read, $data->{$_[1]};
	}
	
	$sth->finish;
	@read;
}

sub read_menu {
	my @read;
	my $sth = $dbh->prepare("SELECT $_[1] FROM $_[0] ORDER BY $_[2] $_[3];");
	$sth->execute;
	while (my $data = $sth->fetchrow_hashref) {
		push @read, $data->{$_[1]};
	}
	$sth->finish;
	@read;
}

	# default_page
sub default_page {
	# @content_date, @content_title, @content
	@content_title = &read_db('topic', 'title', 'tid','DESC');
	@content = &read_db('topic', 'msg', 'tid', 'DESC');
	@content_date = &read_db('topic', 'tdate', 'tid', 'DESC');
	@content_tid = &read_db('topic', 'tid', 'tid', 'DESC');
	@category = &read_db('topic', 'categ', 'tid', 'DESC');
}	# end sub







# Part 2


	# TEMPLATE
my $config = {
    INCLUDE_PATH => ['./template', './'],  # or list ref
    INTERPOLATE  => 0,               # expand "$var" in plain text
    EVAL_PERL    => 1,               # evaluate Perl code blocks
};

# create Template object
my $template = Template->new($config);

# define template variables for replacement
my $vars = {
	'category'		=> \@category,
	'page'			=> $page,
	'menu'			=> \@menu,
	'content_total'=> $#content,
	'content'		=> \@content,
	'content_title'=> \@content_title,
	'content_date'	=> \@content_date,
	'content_tid'	=> \@content_tid,
	'remote_addr'	=> $ENV{'REMOTE_ADDR'},
};

# specify input filename, or file handle, text reference, etc.
my $input = 'main.html';

# process input template, substituting variables
print $q->header;
$template->process($input, $vars) || die $template->error();
	# END TEMPLATE

	# current time
sub time_now {
	my @dates = localtime;
	my @months = qw/January February March April Mei June July August September October November December/;
	my $sec = $dates[0];
	my $min = $dates[1];
	my $hour = $dates[2];
	my $date = $dates[3];
	my $month = $dates[4] + 1;
	my $year = $dates[5] + 1900;
	($sec = '0' . $sec) if length $sec == 1;
	($min = '0' . $min) if length $min == 1;
	($hour = '0' . $hour) if length $hour == 1;
	$date, $month, $year, $hour, $min;
}



sub rand_hex_40{ sha1_hex(rand 99999999) }		# return random hex number (40 digit)


END { $dbh->disconnect }

