#!perl -w

use DBI;

my $dbh = DBI->connect("DBI:SQLite:blogdoor.db.pod", '', '') || die $DBI::errstr;

$dbh->{'RaiseError'} = 1;

$dbh->do("
CREATE TABLE topic(
tid			bigint unsigned,
categ		varchar(20),
poster		varchar(25),
tdate		varchar(20),
title		tinytext,
msg			text,
primary key (tid)
);
") or die $DBI::errstr;

$dbh->do("CREATE TABLE category(categ varchar(20));") or die $DBI::errstr;

$dbh->do("
CREATE TABLE comments(
cid			bigint unsigned,
tid			bigint unsigned,
categ		varchar(20),
ctime		varchar(20),
title		tinytext,
poster		varchar(25),
email		varchar(25),
www			varchar(25),
msg			text,
primary key (cid)
);
") or die $DBI::errstr;

$dbh->do("
CREATE TABLE spamers(
ip			varchar(15),
stime		varchar(20)
);
") or die $DBI::errstr;

$dbh->do("INSERT INTO category (categ) VALUES ('Perl');") or die $DBI::errstr;

$dbh->do("
INSERT INTO topic (tid, categ, poster, tdate, title, msg) VALUES (
1, 'Perl', 'Daniels', '4 04 2007', 'Perl 6 for Real', 'Yeah, Perl 6 Rockz');
") or die $DBI::errstr;


print $DBD::SQLite::VERSION;



__END__

Subject: DBD::SQLite (bug report)
To: Matt Sergeant, matt@sergeant.org

$DBD::SQLite::VERSION = 1.12

DBD::SQLite bugs:

1) I can't put multiple statement in do() & prepare()
    example:
    $dbh->do("
    CREATE TABLE category (cid  varchar(20));
    CREATE TABLE topic (tid  varchar(20));
    ");
 
 only will create one table ``category'' ... *topic* table will not exist
 so I must separate that 2 statement:
 
     $dbh->do("CREATE TABLE category (cid  varchar(20));");
     $dbh->do("CREATE TABLE topic (tid  varchar(20));");     
 
 will work..
 
2) `auto_increment` not work  ?


am using Linux SUSE 10 & Ms WinME



