#!perl -w
#!usr/bin/perl -w


use Cwd;
use lib cwd;

use Math::Matrix;
use CGI qw/:standard :netscape/;
use CGI::Carp qw/fatalsToBrowser/;
use strict;

print header, start_html('Matrix invertor ~ using Math::Matrix');

my $header = <<HTML;
<form method="POST" action="index.cgi">
  Matrix 2 x 2 :<br>
  <input type="text" name="11" size="3">
  <input type="text" name="12" size="3"><br>
  <input type="text" name="21" size="3">
  <input type="text" name="22" size="3"><br>
  <input type="submit" value="Submit" name="B1">
  <input type="reset" value="Reset" name="B2">
  <input type="hidden" name="2x2" value="1">
</form>

<br>
<hr>
<br>

<form method="POST" action="index.cgi">
  Matrix 3 x 3 :<br>
  <input type="text" name="11" size="3">
  <input type="text" name="12" size="3">
  <input type="text" name="13" size="3"><br>
  <input type="text" name="21" size="3">
  <input type="text" name="22" size="3">
  <input type="text" name="23" size="3"><br>
  <input type="text" name="31" size="3">
  <input type="text" name="32" size="3">
  <input type="text" name="33" size="3"><br> 

  <input type="submit" value="Submit" name="B1">
  <input type="reset" value="Reset" name="B2">
  <input type="hidden" name="3x3" value="1">
</form>
HTML


my @matrix;

if (param()) {
	if ( param('2x2') ) {
		@matrix = ( [param('11'), param('12')],
					[param('21'), param('22')] );
		&inverse(@matrix);
	} elsif ( param('3x3') ) {
		@matrix = ( [param('11'), param('12'), param('13')],
					[param('21'), param('22'), param('23')],
					[param('31'), param('32'), param('33')] );
		&inverse(@matrix);
	}
} else {
	print $header;
}

sub inverse {
	my $m = Math::Matrix->new(@_);
	print "Result: <br>\n<pre>";
	$m->invert->print;
	print "</pre>";
	print "<a href=\"index.cgi\">Return to index page</a>";
}

print <<'HTML';
<hr>
<center>
	<b>Inverse matrix in easy way :-)</b> <br>
	<font size="2">Copyright (C) 2007 <a href="mailto:dns@cpan.org">Daniel Sirait</font>
</center>
HTML

print end_html;

