#!perl -w
#!/usr/bin/perl -w

use utf8;

#my $USE_ENGINE = 1;							# 1:mod_perl;  2:CGI/FastCGI/PerlEx

my $SITE_TITLE = 'Cotangen Corporation';
my $SUB_TITLE;
my $SITE = 'http://localhost/metaldoc/';		# must including trailing slash !   # leave blank if you want relative path
my $ADMIN_EMAIL = 'dns@cpan.org';				# your email
my $SCRIPT = 'index.cgi';						# script name, default: webscr.cgi / index.cgi (leave blank if your script is an index page)

my $SCRIPT_ABS_DIR = 'C:/www/metaldoc/';		# include trailing slash
my $EXT_LIB = $SCRIPT_ABS_DIR . 'CPAN/';		# include trailing slash
my $SKIN_REL_DIR = "themes/BlueLeaves/";		# include trailing slash (DON'T CHANGE, UNLESS YOU'RE KNOW WHAT YOU'RE DOING!)
my $DISPLAY = 1;
my $PAGE = 'content.html';						# default page
my ($NODES, $CONTENT, $ERROR, $PAPERS, $MODE);

chdir $SCRIPT_ABS_DIR;
#eval "use lib $EXT_LIB";
#eval "use lib $SCRIPT_ABS_DIR";

use CGI;
use CGI::Carp 'fatalsToBrowser';
use HTML::Template;
use Template;
use strict;

$CGI::POST_MAX = 1024 * 100;				# max 10K posts
$CGI::DISABLE_UPLOADS = 1;					# no uploads

my $tt = Template->new('INCLUDE_PATH' => [$SKIN_REL_DIR, $SCRIPT_ABS_DIR . 'data', $SCRIPT_ABS_DIR . 'paper'],
										#'COMPILE_DIR' => 'temp',
										#'COMPILE_EXT' => '.ttc',
										#'CACHE_SIZE' => 64,			# only cache 64 compiled templates
										'EVAL_PERL' => 0);

#my $tpl = HTML::Template->new(filename => 'test.tmpl');

my $cgi = CGI->new;

# CGI param
my $q = $cgi->param('q');	# query, cmd
my $c = $cgi->param('c');	# category, nodes
my $p = $cgi->param('p');	# paper
#$q = 'browse_papers';

if ($c) {
	load_node();
	read_node($c);
	$SUB_TITLE = $c;
} elsif ($p) {
	load_node();
	read_paper($p);
} elsif ($q) {
	#if ($q eq 'browse_papers') {
		$PAGE = 'browse_papers.html';
		load_node();
		browse_papers();
		#print '11111111111111111111';
	#}
} else {
	load_node();
	read_node('home');		# default node for index page is 'home'
	$SUB_TITLE = 'Home';
}

&send_response;



# SUB ROUTINES

sub read_node {
	$CONTENT = $_[0] . '.txt';
}

sub load_node {
	open FH, "nodes.txt" or die $!;
	my $raw = join '', <FH>;
	close FH;
	my @raw_nodes = split "\n", $raw;
	my $i = 0;
	for my $z (@raw_nodes) {
		my ($x, $y) = split ' = ', $z;
		$NODES->[$i]->{'name'} = $x;
		$NODES->[$i]->{'title'} = $y;
		$i++;
	}
}


sub browse_papers {
	opendir DIR, "paper" or die $!;
	my $i = 0;
	while (my $paper = readdir(DIR)) {
		unless ($paper eq '.' or $paper eq '..') {
			$paper =~ s/\.txt$//;
			$PAPERS->[$i]->{paper} = $paper;
			$i++;
		}
	}
	closedir DIR;
}

sub read_paper {
	$CONTENT = $_[0] . '.txt';
}


##### TEMPLATE LOADER

sub read_template {
	open FH, $_[0] or die $!;
	my $tpl = join '', <FH>;
	close FH;
	$tpl =~ s/\$PAGE/$PAGE/g;
	$tpl =~ s/\$CONTENT/$CONTENT/g;
	$tpl =~ s/\$NODES/$NODES/g;
	#$tpl =~ s/\$/$/g;
}


#### RESPONSE HANDLER

sub send_response {
	my $vars = {
		'page'		=> $PAGE,
		'content'	=> $CONTENT,
		'nodes'		=> $NODES,
		'papers'	=> $PAPERS,
		'error'		=> $ERROR,
		'site_title'	=> $SITE_TITLE,
		'site'		=> $SITE,
		'skin_path'	=> $SKIN_REL_DIR,
		'admin_email'	=> $ADMIN_EMAIL,
		'script'	=> $SCRIPT,
		'sub_title'	=> $SUB_TITLE,
	};
	if ($DISPLAY == 1) {
		print $cgi->header('-x-powered-by' => 'Perl/5.8.8');
		$tt->process('main.html', $vars) or die($tt->error);
	} else {
		print $cgi->header('-x-powered-by' => 'Perl/5.8.8');
		die "No Display\n";
	}
}



