#!perl -w


my $DIR = 'C:/www/nitro/';
my $THEME = 'antique_modern';
my $TITLE = 'Daniel Sirait';
my $SCRIPT = 'nitro.cgi';
my $SITE = 'http://www.tetasoft.com/nitrogen/';

my $ENGINE = 'FastCGI';

my $PASSWORD = 'dgdgdg';

# important !! for mod_perl users
chdir "$DIR";
push @INC, $DIR;

do "plugin.cfg";



if ($ENGINE =~ m/fastcgi/i) {
	require FCGI;
	my $count = 0;
	my $request = FCGI::Request();
	while($request->Accept() >= 0) {
		run();
	}
} else {
	run();
}

sub run {
my $nitro = Nitro->new(
			'theme' => $THEME,
			'title' => $TITLE,
			'script' => $SCRIPT,
			'site' => $SITE,
			'password' => $PASSWORD,
		);

$nitro->init;
$nitro->run;
}





######### NITRO #########

package Nitro;

use CGI::Carp 'fatalsToBrowser';
use CGI qw(:stardard :netscape escapeHTML);
#use autouse 'CGI::Cookie';
use CGI::Cookie;
use Exporter;
use strict;


our @ISA = qw(Exporter);
our @EXPORT = qw(escapeHTML param);
our @EXPORT_OK = qw($CGI::POST_MAX $CGI::DISABLE_UPLOADS);

our ($site, $themedir, $page, $title, $script, $Content) = undef;


sub new {
	my $class = shift;
	my %new = @_;
	my $self = {
			'_cgi' => CGI->new,
			#'themedir' => $new{site} . 'themes/' . $new{theme} . '/',
			'title' => $new{title},
			'script' => $new{script},
			'site'	=> $new{site},
			#'user_type' => undef,		# 0
			'cookie' => undef,
			'password' => $new{password},
			'send_cookie' => undef,
			'theme' => $new{theme},
			'page' => 'main.html',
			'logged_in' => 0,
			};
	
	$Nitro::site = $new{site};
	$Nitro::themedir = $Nitro::site . 'themes/' . $new{theme} . '/';
	$Nitro::page  = 'main.html';
	$Nitro::title = $new{title};
	$Nitro::script = $new{script};
	$Nitro::display = 1;
	#print $Nitro::themedir;
	return bless $self, $class;
}

sub init {
	my $nitro = shift;
	$CGI::POST_MAX = 1024 * 10000;  # max 10 MB posts
	$CGI::DISABLE_UPLOADS = 0;  # no uploads
	$nitro->{page} = $Nitro::page;
}

DESTROY {
	my $nitro = shift;
	#CGI::initialize_globals;
	undef %$nitro;
	#($site, $themedir, $page, $title, $script, $Content) = undef;
}


sub run {
	my $nitro = shift;
	my @plugins;
	
	if ($nitro->get_cookie) {
		if ($nitro->{cookie}{password} eq $nitro->{password}) {
			$nitro->{page} = 'admin.html';
			$nitro->{logged_in} = 1;
		} else {
			die "Expired session!\n";
		}
	}
	
	if ($nitro->{_cgi}->param('cmd')) {
		if ($nitro->{_cgi}->param('cmd') eq 'plug') {
			@plugins = $nitro->plugin_load(1);
		} elsif ($nitro->{_cgi}->param('cmd') eq 'login') {
			@plugins = $nitro->plugin_load(0);
			$nitro->login;
			# $Nitro::Login
		} elsif ($nitro->{_cgi}->param('cmd') eq 'admin') {
			@plugins = $nitro->plugin_load(0);
			$nitro->admin;
		} elsif ($nitro->{_cgi}->param('cmd') eq 'logout') {
			@plugins = $nitro->plugin_load(1);
			$nitro->logout;
			# plugin_load
		}
	} else {
		# plugin_load
		if ($nitro->{logged_in} == 1) {
			# read plugins / manual
			@plugins = $nitro->plugin_load(0);
			$nitro->admin::viewplugin;
		} else {
			@plugins = $nitro->plugin_load(1);
		}
	}
	
	# $Nitro::display = 0 -> handle different MIME types or Redirecting pages or returns XML (RDF/RSS) feed (but only implemented in Plugins)
	if ($Nitro::display) {
		$nitro->template;
		$nitro->populate(\$Nitro::template);
		$nitro->display;
	}
}

sub plugin_load {
	my $nitro = shift;
	my @plugins;
	opendir DIR, 'plugins' or die $!;
	while (my $plugin = readdir (DIR)) {
		if ($plugin !~ m/^(\.|\.\.)$/ and $plugin =~ m/\.pm$/) {
			$plugin =~ s/\.pm$//;
			if ($_[0] == 1) {
				require "plugins/$plugin.pm";
				my $eval = "\$nitro->Nitro::$plugin" . "::init\n";		# unnecessary !!! use run() directly in Nitro::XYZ instead
				eval $eval;
			}
			push @plugins, $plugin;
		}
	}
	closedir DIR or die $!;
	return @plugins;
}

sub template {
	my $nitro = shift;
	open FH, "themes/$nitro->{theme}/$nitro->{page}" or die "Can't open template file $nitro->{page}\n" or die $!;
	$Nitro::template = join '', <FH>;
	close FH or die $!;
}

sub populate {
	my $nitro = shift;
	${$_[0]} =~ s/\[\s*?(\$Nitro\:\:.+?)\s*?\]/$nitro->eval_var_template($1)/ge;
	${$_[0]} =~ s/\[\s*?include\s*?\(\s*?\'(.*?)\s*?\'\s*?\)\s*?\]/$nitro->eval_include_template($1)/ge;
}

sub eval_include_template {
	my $nitro = shift;
	open FH, "themes/$nitro->{theme}/$_[0]" or die $_[0];
	my $file = join '', <FH>;
	close FH or die $_[0];
	$nitro->populate(\$file);		# recursive calls, avoid huge memory usage
	return $file;
}

sub eval_var_template {
	my $nitro = shift;
	my $x;
	eval "\$x = $_[0];";
	return $x;
}

sub display {
	my $nitro = shift;
	if ($nitro->{send_cookie}) {
		print $nitro->{_cgi}->header(-cookie=>[$nitro->create_cookie]), $Nitro::template;
	} else {
		print $nitro->{_cgi}->header, $Nitro::template;
	}
}


####### END #########

sub admin {
	my $nitro = shift;
	my $plugin = $nitro->{_cgi}->param('plugin');
	$nitro->{page} = 'admin.html';
	if ($nitro->{logged_in}) {
		if ($plugin !~ m/\W/) {
			require "plugins/$plugin.pm";
			$plugin =~ s/\.pm$//;
			my $eval = "\$nitro->Nitro::$plugin" . "::admin\n";
			eval $eval;
		}
	}
}

sub admin::viewplugin {
	my $nitro = shift;
	for my $i ($nitro->plugin_load(0)) {
		$Nitro::Content .= "<a href=\"$nitro->{script}?cmd=admin;plugin=$i\">$i</a><br>\n";
	}
}

sub redirect {
	my $nitro = shift;
	$Nitro::display = 0;
	print $nitro->{_cgi}->redirect($_[0]);
}

sub login {
	my $nitro = shift;
	$nitro->get_cookie;
	if ($nitro->{_cgi}->param('password') and $nitro->{password}) {
		if ($nitro->{_cgi}->param('password') eq $nitro->{password}) {
			# view admin page
			# send new cookie
			$nitro->{send_cookie} = '+1h';
			$nitro->{page} = 'admin.html';
			# plugin_load() -> return array
			$nitro->admin::viewplugin;
		} elsif ($nitro->{_cgi}->param('password') ne $nitro->{password}) {
			$nitro->{page} = 'login.html';
			$Nitro::Content = '<font color="red">Incorrect Password!</font><br>';
		}
	} else {
		$nitro->{page} = 'login.html';
	}
}

sub logout {
	my $nitro = shift;
	$nitro->{logged_in} = 0;
	$nitro->{send_cookie} = '-2h';		# heh heh
	$nitro->{page} = 'main.html';
}

sub get_cookie {
	my $self = shift;
	my ($raw_cookie, $key, $value);	#, %results);
	
	$raw_cookie = $ENV{HTTP_COOKIE};	# || $ENV{COOKIE};
	if (defined $raw_cookie) {
		my (@pairs) = split('; ', $raw_cookie);
		for my $i (@pairs) {
			$i =~ s/\s*(.*?)\s*/$1/;
			if ($i =~ /^([^=]+)=(.*)/) {
				$key = $1;
				$value = $2;
			} else {
				$key = $i;
				$value = undef;
			}
			$self->{cookie}{$key} = $value;
		}
		return 1;
	} else {
		undef $self->{cookie};
		return 0;
	}
}

sub create_cookie {
	my $nitro = shift;
	my $new_cookie = CGI::Cookie->new(	-name=> 'password',
										-value=> $nitro->{password},
										-expires => $nitro->{send_cookie},
									);
	#$self->{misc}{cookie_object} = $new_cookie;
	return $new_cookie;
}



__END__

populates

$Nitro::Content









