#!perl -w
#!/usr/bin/perl -w

chdir 'C:/www/smoke/';

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Data::Dumper;
use Template;
use File::Basename;
use strict;

my $q = CGI->new;

# some useful options (see below for full list)
my $config = {
	INCLUDE_PATH => ['template/'],# or list ref
	POST_CHOMP => 1, # cleanup whitespace
	EVAL_PERL=> 1, # evaluate Perl code blocks
};

# create Template object
my $t = Template->new($config);


my $current_dir = 'dist/';

# specify input filename, or file handle, text reference, etc.
my $page = 'template.html';

sub smoke_read {
	my (@files, @is_dir, @sizes, @modified);
	opendir DH, 'smokehome/' . $_[0];
	while (my $file = readdir DH) {
		unless ($file eq '.' or $file eq '..') {
			#push @files, 'smokehome/' . $_[0] . $file;
			push @files, $file;
			my @stat = stat 'smokehome/' . $_[0] . $file;
			push @modified, join('-', gmtime $stat[9]);
			if (-d 'smokehome/' . $_[0] . $file) {
				push @is_dir, 1;
				push @sizes, '-';
			} else {
				push @is_dir, 0;
				push @sizes, $stat[7];
			}
		}
	}
	closedir DH;
	return {'files'=>[@files], 'is_dir'=>[@is_dir], sizes=>[@sizes], modified=>[@modified]};
}

#my $chdir = '';

if ($q->param('chdir')) {
	$current_dir = $current_dir . $q->param('chdir');
} elsif ($q->param('up') eq '1') {
	if ($q->param('dir') eq 'dist/') {
		print $q->redirect('index.cgi');
		return 0;
	}
	
	$current_dir = dirname($q->param('dir')) . '/';
}

my $content = smoke_read($current_dir);

$page = 'template.html';

my $vars = {
	'content' => $content,
	'current_dir' => $current_dir,
};


print $q->header(-type=>'text/html',
				-charset=>'utf-8',
				#-attachment=>'foo.gif',
				#-nph=>0,
				#-status=>'402 Payment required',
				-expires=>'+3d',
				-cookie=>'abc',
				-p3p=>'CAO DSP LAW CURa',
				);
$t->process($page, $vars) || die $t->error();


















